/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.Cursor;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.apache.batik.dom.events.AbstractEvent;
/*     */ import org.apache.batik.dom.events.NodeEventTarget;
/*     */ import org.apache.batik.dom.svg.SVGOMAElement;
/*     */ import org.apache.batik.dom.svg.SVGOMAnimationElement;
/*     */ import org.apache.batik.dom.svg.SVGOMDocument;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.events.Event;
/*     */ import org.w3c.dom.events.EventListener;
/*     */ import org.w3c.dom.svg.SVGAElement;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGAElementBridge
/*     */   extends SVGGElementBridge
/*     */ {
/*     */   protected AnchorListener al;
/*     */   protected CursorMouseOverListener bl;
/*     */   protected CursorMouseOutListener cl;
/*     */   
/*  61 */   public String getLocalName() { return "a"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  68 */   public Bridge getInstance() { return new SVGAElementBridge(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void buildGraphicsNode(BridgeContext ctx, Element e, GraphicsNode node) {
/*  83 */     super.buildGraphicsNode(ctx, e, node);
/*     */     
/*  85 */     if (ctx.isInteractive()) {
/*  86 */       NodeEventTarget target = (NodeEventTarget)e;
/*  87 */       CursorHolder ch = new CursorHolder(CursorManager.DEFAULT_CURSOR);
/*     */       
/*  89 */       this.al = new AnchorListener(ctx.getUserAgent(), ch);
/*  90 */       target.addEventListenerNS("http://www.w3.org/2001/xml-events", "click", this.al, false, null);
/*     */ 
/*     */       
/*  93 */       ctx.storeEventListenerNS(target, "http://www.w3.org/2001/xml-events", "click", this.al, false);
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*  98 */       this.bl = new CursorMouseOverListener(ctx.getUserAgent(), ch);
/*  99 */       target.addEventListenerNS("http://www.w3.org/2001/xml-events", "mouseover", this.bl, false, null);
/*     */ 
/*     */       
/* 102 */       ctx.storeEventListenerNS(target, "http://www.w3.org/2001/xml-events", "mouseover", this.bl, false);
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 107 */       this.cl = new CursorMouseOutListener(ctx.getUserAgent(), ch);
/* 108 */       target.addEventListenerNS("http://www.w3.org/2001/xml-events", "mouseout", this.cl, false, null);
/*     */ 
/*     */       
/* 111 */       ctx.storeEventListenerNS(target, "http://www.w3.org/2001/xml-events", "mouseout", this.cl, false);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispose() {
/* 119 */     NodeEventTarget target = (NodeEventTarget)this.e;
/* 120 */     if (this.al != null) {
/* 121 */       target.removeEventListenerNS("http://www.w3.org/2001/xml-events", "click", this.al, false);
/*     */ 
/*     */       
/* 124 */       this.al = null;
/*     */     } 
/* 126 */     if (this.bl != null) {
/* 127 */       target.removeEventListenerNS("http://www.w3.org/2001/xml-events", "mouseover", this.bl, false);
/*     */ 
/*     */       
/* 130 */       this.bl = null;
/*     */     } 
/* 132 */     if (this.cl != null) {
/* 133 */       target.removeEventListenerNS("http://www.w3.org/2001/xml-events", "mouseout", this.cl, false);
/*     */ 
/*     */       
/* 136 */       this.cl = null;
/*     */     } 
/* 138 */     super.dispose();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 145 */   public boolean isComposite() { return true; }
/*     */   
/*     */   public static class CursorHolder {
/*     */     public CursorHolder(Cursor c) {
/* 149 */       this.cursor = null;
/*     */ 
/*     */       
/* 152 */       this.cursor = c;
/*     */     }
/*     */ 
/*     */     
/* 156 */     public void holdCursor(Cursor c) { this.cursor = c; }
/*     */     Cursor cursor;
/*     */     
/* 159 */     public Cursor getCursor() { return this.cursor; }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class AnchorListener
/*     */     implements EventListener
/*     */   {
/*     */     protected UserAgent userAgent;
/*     */     
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public AnchorListener(UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 171 */       this.userAgent = ua;
/* 172 */       this.holder = ch;
/*     */     }
/*     */     
/*     */     public void handleEvent(Event evt) {
/* 176 */       if (!(evt instanceof AbstractEvent))
/* 177 */         return;  AbstractEvent ae = (AbstractEvent)evt;
/*     */       
/* 179 */       List l = ae.getDefaultActions();
/* 180 */       if (l != null) {
/* 181 */         Iterator i = l.iterator();
/* 182 */         while (i.hasNext()) {
/* 183 */           Object o = i.next();
/* 184 */           if (o instanceof SVGAElementBridge.AnchorDefaultActionable) {
/*     */             return;
/*     */           }
/*     */         } 
/*     */       } 
/*     */       
/* 190 */       SVGAElement elt = (SVGAElement)evt.getCurrentTarget();
/* 191 */       ae.addDefaultAction(new SVGAElementBridge.AnchorDefaultActionable(elt, this.userAgent, this.holder));
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class AnchorDefaultActionable
/*     */     implements Runnable
/*     */   {
/*     */     protected SVGOMAElement elt;
/*     */     
/*     */     protected UserAgent userAgent;
/*     */     
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public AnchorDefaultActionable(SVGAElement e, UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 206 */       this.elt = (SVGOMAElement)e;
/* 207 */       this.userAgent = ua;
/* 208 */       this.holder = ch;
/*     */     }
/*     */     
/*     */     public void run() {
/* 212 */       this.userAgent.setSVGCursor(this.holder.getCursor());
/* 213 */       String href = this.elt.getHref().getAnimVal();
/* 214 */       ParsedURL purl = new ParsedURL(this.elt.getBaseURI(), href);
/* 215 */       SVGOMDocument doc = (SVGOMDocument)this.elt.getOwnerDocument();
/* 216 */       ParsedURL durl = doc.getParsedURL();
/* 217 */       if (purl.sameFile(durl)) {
/* 218 */         String frag = purl.getRef();
/* 219 */         if (frag != null && frag.length() != 0) {
/* 220 */           Element refElt = doc.getElementById(frag);
/* 221 */           if (refElt instanceof SVGOMAnimationElement) {
/* 222 */             SVGOMAnimationElement aelt = (SVGOMAnimationElement)refElt;
/*     */             
/* 224 */             float t = aelt.getHyperlinkBeginTime();
/* 225 */             if (Float.isNaN(t)) {
/* 226 */               aelt.beginElement();
/*     */             } else {
/* 228 */               doc.getRootElement().setCurrentTime(t);
/*     */             } 
/*     */             return;
/*     */           } 
/*     */         } 
/*     */       } 
/* 234 */       this.userAgent.openLink(this.elt);
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class CursorMouseOverListener
/*     */     implements EventListener
/*     */   {
/*     */     protected UserAgent userAgent;
/*     */     
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public CursorMouseOverListener(UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 247 */       this.userAgent = ua;
/* 248 */       this.holder = ch;
/*     */     }
/*     */     
/*     */     public void handleEvent(Event evt) {
/* 252 */       if (!(evt instanceof AbstractEvent))
/* 253 */         return;  AbstractEvent ae = (AbstractEvent)evt;
/*     */       
/* 255 */       List l = ae.getDefaultActions();
/* 256 */       if (l != null) {
/* 257 */         Iterator i = l.iterator();
/* 258 */         while (i.hasNext()) {
/* 259 */           Object o = i.next();
/* 260 */           if (o instanceof SVGAElementBridge.MouseOverDefaultActionable) {
/*     */             return;
/*     */           }
/*     */         } 
/*     */       } 
/* 265 */       Element target = (Element)ae.getTarget();
/* 266 */       SVGAElement elt = (SVGAElement)ae.getCurrentTarget();
/*     */       
/* 268 */       ae.addDefaultAction(new SVGAElementBridge.MouseOverDefaultActionable(target, elt, this.userAgent, this.holder));
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class MouseOverDefaultActionable
/*     */     implements Runnable
/*     */   {
/*     */     protected Element target;
/*     */     
/*     */     protected SVGAElement elt;
/*     */     
/*     */     protected UserAgent userAgent;
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public MouseOverDefaultActionable(Element t, SVGAElement e, UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 284 */       this.target = t;
/* 285 */       this.elt = e;
/* 286 */       this.userAgent = ua;
/* 287 */       this.holder = ch;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void run() {
/* 308 */       if (CSSUtilities.isAutoCursor(this.target)) {
/* 309 */         this.holder.holdCursor(CursorManager.DEFAULT_CURSOR);
/*     */         
/* 311 */         this.userAgent.setSVGCursor(CursorManager.ANCHOR_CURSOR);
/*     */       } 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 317 */       if (this.elt != null) {
/* 318 */         String href = this.elt.getHref().getAnimVal();
/* 319 */         this.userAgent.displayMessage(href);
/*     */       } 
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class CursorMouseOutListener
/*     */     implements EventListener
/*     */   {
/*     */     protected UserAgent userAgent;
/*     */     
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public CursorMouseOutListener(UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 333 */       this.userAgent = ua;
/* 334 */       this.holder = ch;
/*     */     }
/*     */     
/*     */     public void handleEvent(Event evt) {
/* 338 */       if (!(evt instanceof AbstractEvent))
/* 339 */         return;  AbstractEvent ae = (AbstractEvent)evt;
/*     */       
/* 341 */       List l = ae.getDefaultActions();
/* 342 */       if (l != null) {
/* 343 */         Iterator i = l.iterator();
/* 344 */         while (i.hasNext()) {
/* 345 */           Object o = i.next();
/* 346 */           if (o instanceof SVGAElementBridge.MouseOutDefaultActionable) {
/*     */             return;
/*     */           }
/*     */         } 
/*     */       } 
/* 351 */       SVGAElement elt = (SVGAElement)evt.getCurrentTarget();
/* 352 */       ae.addDefaultAction(new SVGAElementBridge.MouseOutDefaultActionable(elt, this.userAgent, this.holder));
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public static class MouseOutDefaultActionable
/*     */     implements Runnable
/*     */   {
/*     */     protected SVGAElement elt;
/*     */     
/*     */     protected UserAgent userAgent;
/*     */     protected SVGAElementBridge.CursorHolder holder;
/*     */     
/*     */     public MouseOutDefaultActionable(SVGAElement e, UserAgent ua, SVGAElementBridge.CursorHolder ch) {
/* 366 */       this.elt = e;
/* 367 */       this.userAgent = ua;
/* 368 */       this.holder = ch;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void run() {
/* 376 */       if (this.elt != null)
/* 377 */         this.userAgent.displayMessage(""); 
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGAElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */