/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.color.ICC_Profile;
/*     */ import java.io.IOException;
/*     */ import org.apache.batik.dom.AbstractNode;
/*     */ import org.apache.batik.dom.util.XLinkSupport;
/*     */ import org.apache.batik.ext.awt.color.ICCColorSpaceExt;
/*     */ import org.apache.batik.ext.awt.color.NamedProfileCache;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGColorProfileElementBridge
/*     */   extends AbstractSVGBridge
/*     */   implements ErrorConstants
/*     */ {
/*  47 */   public NamedProfileCache cache = new NamedProfileCache();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  53 */   public String getLocalName() { return "color-profile"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ICCColorSpaceExt createICCColorSpaceExt(BridgeContext ctx, Element paintedElement, String iccProfileName) {
/*  69 */     ICCColorSpaceExt cs = this.cache.request(iccProfileName.toLowerCase());
/*  70 */     if (cs != null) {
/*  71 */       return cs;
/*     */     }
/*     */ 
/*     */ 
/*     */     
/*  76 */     Document doc = paintedElement.getOwnerDocument();
/*  77 */     NodeList list = doc.getElementsByTagNameNS("http://www.w3.org/2000/svg", "color-profile");
/*     */ 
/*     */     
/*  80 */     int n = list.getLength();
/*  81 */     Element profile = null;
/*  82 */     for (int i = 0; i < n; i++) {
/*  83 */       Node node = list.item(i);
/*  84 */       if (node.getNodeType() == 1) {
/*  85 */         Element profileNode = (Element)node;
/*  86 */         String nameAttr = profileNode.getAttributeNS(null, "name");
/*     */ 
/*     */         
/*  89 */         if (iccProfileName.equalsIgnoreCase(nameAttr)) {
/*  90 */           profile = profileNode;
/*     */         }
/*     */       } 
/*     */     } 
/*     */     
/*  95 */     if (profile == null) {
/*  96 */       return null;
/*     */     }
/*     */ 
/*     */     
/* 100 */     String href = XLinkSupport.getXLinkHref(profile);
/* 101 */     ICC_Profile p = null;
/* 102 */     if (href != null) {
/* 103 */       String baseURI = ((AbstractNode)profile).getBaseURI();
/* 104 */       ParsedURL pDocURL = null;
/* 105 */       if (baseURI != null) {
/* 106 */         pDocURL = new ParsedURL(baseURI);
/*     */       }
/*     */       
/* 109 */       ParsedURL purl = new ParsedURL(pDocURL, href);
/* 110 */       if (!purl.complete()) {
/* 111 */         throw new BridgeException(ctx, paintedElement, "uri.malformed", new Object[] { href });
/*     */       }
/*     */       try {
/* 114 */         ctx.getUserAgent().checkLoadExternalResource(purl, pDocURL);
/* 115 */         p = ICC_Profile.getInstance(purl.openStream());
/*     */       } catch (IOException ioEx) {
/* 117 */         throw new BridgeException(ctx, paintedElement, ioEx, "uri.io", new Object[] { href });
/*     */       }
/*     */       catch (SecurityException secEx) {
/*     */         
/* 121 */         throw new BridgeException(ctx, paintedElement, secEx, "uri.unsecure", new Object[] { href });
/*     */       } 
/*     */     } 
/*     */     
/* 125 */     if (p == null) {
/* 126 */       return null;
/*     */     }
/*     */ 
/*     */     
/* 130 */     int intent = convertIntent(profile, ctx);
/* 131 */     cs = new ICCColorSpaceExt(p, intent);
/*     */ 
/*     */     
/* 134 */     this.cache.put(iccProfileName.toLowerCase(), cs);
/* 135 */     return cs;
/*     */   }
/*     */ 
/*     */   
/*     */   private static int convertIntent(Element profile, BridgeContext ctx) {
/* 140 */     String intent = profile.getAttributeNS(null, "rendering-intent");
/*     */ 
/*     */     
/* 143 */     if (intent.length() == 0) {
/* 144 */       return 4;
/*     */     }
/* 146 */     if ("perceptual".equals(intent)) {
/* 147 */       return 0;
/*     */     }
/* 149 */     if ("auto".equals(intent)) {
/* 150 */       return 4;
/*     */     }
/* 152 */     if ("relative-colorimetric".equals(intent)) {
/* 153 */       return 1;
/*     */     }
/* 155 */     if ("absolute-colorimetric".equals(intent)) {
/* 156 */       return 2;
/*     */     }
/* 158 */     if ("saturation".equals(intent)) {
/* 159 */       return 3;
/*     */     }
/* 161 */     throw new BridgeException(ctx, profile, "attribute.malformed", new Object[] { "rendering-intent", intent });
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGColorProfileElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */