/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import org.apache.batik.css.engine.CSSEngineEvent;
/*     */ import org.apache.batik.dom.svg.AnimatedLiveAttributeValue;
/*     */ import org.apache.batik.dom.svg.SVGContext;
/*     */ import org.apache.batik.dom.svg.SVGOMElement;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.events.MutationEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class SVGDescriptiveElementBridge
/*     */   extends AbstractSVGBridge
/*     */   implements GenericBridge, BridgeUpdateHandler, SVGContext
/*     */ {
/*     */   Element theElt;
/*     */   Element parent;
/*     */   BridgeContext theCtx;
/*     */   
/*     */   public void handleElement(BridgeContext ctx, Element e) {
/*  59 */     UserAgent ua = ctx.getUserAgent();
/*  60 */     ua.handleElement(e, Boolean.TRUE);
/*     */     
/*  62 */     if (ctx.isDynamic()) {
/*     */       
/*  64 */       SVGDescriptiveElementBridge b = (SVGDescriptiveElementBridge)getInstance();
/*  65 */       b.theElt = e;
/*  66 */       b.parent = (Element)e.getParentNode();
/*  67 */       b.theCtx = ctx;
/*  68 */       ((SVGOMElement)e).setSVGContext(b);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispose() {
/*  76 */     UserAgent ua = this.theCtx.getUserAgent();
/*  77 */     ((SVGOMElement)this.theElt).setSVGContext(null);
/*  78 */     ua.handleElement(this.theElt, this.parent);
/*  79 */     this.theElt = null;
/*  80 */     this.parent = null;
/*     */   }
/*     */   public void handleDOMNodeInsertedEvent(MutationEvent evt) {
/*  83 */     UserAgent ua = this.theCtx.getUserAgent();
/*  84 */     ua.handleElement(this.theElt, Boolean.TRUE);
/*     */   }
/*     */   public void handleDOMCharacterDataModified(MutationEvent evt) {
/*  87 */     UserAgent ua = this.theCtx.getUserAgent();
/*  88 */     ua.handleElement(this.theElt, Boolean.TRUE);
/*     */   }
/*     */ 
/*     */   
/*  92 */   public void handleDOMNodeRemovedEvent(MutationEvent evt) { dispose(); }
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMAttrModifiedEvent(MutationEvent evt) {}
/*     */ 
/*     */   
/*     */   public void handleCSSEngineEvent(CSSEngineEvent evt) {}
/*     */ 
/*     */   
/*     */   public void handleAnimatedAttributeChanged(AnimatedLiveAttributeValue alav) {}
/*     */ 
/*     */   
/*     */   public void handleOtherAnimationChanged(String type) {}
/*     */ 
/*     */   
/* 108 */   public float getPixelUnitToMillimeter() { return this.theCtx.getUserAgent().getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 117 */   public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */   
/* 121 */   public Rectangle2D getBBox() { return null; }
/*     */   
/* 123 */   public AffineTransform getScreenTransform() { return this.theCtx.getUserAgent().getTransform(); }
/*     */ 
/*     */   
/* 126 */   public void setScreenTransform(AffineTransform at) { this.theCtx.getUserAgent().setTransform(at); }
/*     */   
/* 128 */   public AffineTransform getCTM() { return null; }
/* 129 */   public AffineTransform getGlobalTransform() { return null; }
/*     */   
/* 131 */   public float getViewportWidth() { return this.theCtx.getBlockWidth(this.theElt); }
/*     */ 
/*     */   
/* 134 */   public float getViewportHeight() { return this.theCtx.getBlockHeight(this.theElt); }
/*     */   
/* 136 */   public float getFontSize() { return 0.0F; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGDescriptiveElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */