/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import org.apache.batik.css.engine.CSSEngineEvent;
/*     */ import org.apache.batik.dom.svg.AnimatedLiveAttributeValue;
/*     */ import org.apache.batik.dom.svg.SVGContext;
/*     */ import org.apache.batik.dom.svg.SVGOMDocument;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.apache.batik.gvt.RootGraphicsNode;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.events.MutationEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGDocumentBridge
/*     */   implements DocumentBridge, BridgeUpdateHandler, SVGContext
/*     */ {
/*     */   protected Document document;
/*     */   protected RootGraphicsNode node;
/*     */   protected BridgeContext ctx;
/*     */   
/*  73 */   public String getNamespaceURI() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  81 */   public String getLocalName() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  88 */   public Bridge getInstance() { return new SVGDocumentBridge(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RootGraphicsNode createGraphicsNode(BridgeContext ctx, Document doc) {
/* 104 */     RootGraphicsNode gn = new RootGraphicsNode();
/* 105 */     this.document = doc;
/* 106 */     this.node = gn;
/* 107 */     this.ctx = ctx;
/* 108 */     ((SVGOMDocument)doc).setSVGContext(this);
/* 109 */     return gn;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void buildGraphicsNode(BridgeContext ctx, Document doc, RootGraphicsNode node) {
/* 126 */     if (ctx.isDynamic()) {
/* 127 */       ctx.bind(doc, node);
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMAttrModifiedEvent(MutationEvent evt) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMNodeInsertedEvent(MutationEvent evt) {
/* 143 */     if (evt.getTarget() instanceof Element) {
/* 144 */       Element childElt = (Element)evt.getTarget();
/*     */       
/* 146 */       GVTBuilder builder = this.ctx.getGVTBuilder();
/* 147 */       GraphicsNode childNode = builder.build(this.ctx, childElt);
/* 148 */       if (childNode == null) {
/*     */         return;
/*     */       }
/*     */ 
/*     */       
/* 153 */       this.node.add(childNode);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMNodeRemovedEvent(MutationEvent evt) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMCharacterDataModified(MutationEvent evt) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleCSSEngineEvent(CSSEngineEvent evt) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleAnimatedAttributeChanged(AnimatedLiveAttributeValue alav) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleOtherAnimationChanged(String type) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispose() {
/* 192 */     ((SVGOMDocument)this.document).setSVGContext(null);
/* 193 */     this.ctx.unbind(this.document);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 202 */   public float getPixelUnitToMillimeter() { return this.ctx.getUserAgent().getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 211 */   public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*     */ 
/*     */   
/* 214 */   public Rectangle2D getBBox() { return null; }
/*     */   
/* 216 */   public AffineTransform getScreenTransform() { return this.ctx.getUserAgent().getTransform(); }
/*     */ 
/*     */   
/* 219 */   public void setScreenTransform(AffineTransform at) { this.ctx.getUserAgent().setTransform(at); }
/*     */   
/* 221 */   public AffineTransform getCTM() { return null; }
/* 222 */   public AffineTransform getGlobalTransform() { return null; }
/* 223 */   public float getViewportWidth() { return 0.0F; }
/* 224 */   public float getViewportHeight() { return 0.0F; }
/* 225 */   public float getFontSize() { return 0.0F; }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGDocumentBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */