/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.util.Map;
/*     */ import org.apache.batik.ext.awt.image.Light;
/*     */ import org.apache.batik.ext.awt.image.renderable.Filter;
/*     */ import org.apache.batik.ext.awt.image.renderable.SpecularLightingRable8Bit;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGFeSpecularLightingElementBridge
/*     */   extends AbstractSVGLightingElementBridge
/*     */ {
/*  49 */   public String getLocalName() { return "feSpecularLighting"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Filter createFilter(BridgeContext ctx, Element filterElement, Element filteredElement, GraphicsNode filteredNode, Filter inputFilter, Rectangle2D filterRegion, Map filterMap) {
/*  80 */     float surfaceScale = AbstractSVGFilterPrimitiveElementBridge.convertNumber(filterElement, "surfaceScale", 1.0F, ctx);
/*     */ 
/*     */ 
/*     */     
/*  84 */     float specularConstant = AbstractSVGFilterPrimitiveElementBridge.convertNumber(filterElement, "specularConstant", 1.0F, ctx);
/*     */ 
/*     */ 
/*     */     
/*  88 */     float specularExponent = convertSpecularExponent(filterElement, ctx);
/*     */ 
/*     */     
/*  91 */     Light light = AbstractSVGLightingElementBridge.extractLight(filterElement, ctx);
/*     */ 
/*     */     
/*  94 */     double[] kernelUnitLength = AbstractSVGLightingElementBridge.convertKernelUnitLength(filterElement, ctx);
/*     */ 
/*     */     
/*  97 */     Filter in = AbstractSVGFilterPrimitiveElementBridge.getIn(filterElement, filteredElement, filteredNode, inputFilter, filterMap, ctx);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 103 */     if (in == null) {
/* 104 */       return null;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 110 */     Rectangle2D defaultRegion = in.getBounds2D();
/* 111 */     Rectangle2D primitiveRegion = SVGUtilities.convertFilterPrimitiveRegion(filterElement, filteredElement, filteredNode, defaultRegion, filterRegion, ctx);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 119 */     SpecularLightingRable8Bit specularLightingRable8Bit = new SpecularLightingRable8Bit(in, primitiveRegion, light, specularConstant, specularExponent, surfaceScale, kernelUnitLength);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 129 */     AbstractSVGFilterPrimitiveElementBridge.handleColorInterpolationFilters(specularLightingRable8Bit, filterElement);
/*     */ 
/*     */     
/* 132 */     AbstractSVGFilterPrimitiveElementBridge.updateFilterMap(filterElement, specularLightingRable8Bit, filterMap);
/*     */     
/* 134 */     return specularLightingRable8Bit;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static float convertSpecularExponent(Element filterElement, BridgeContext ctx) {
/* 146 */     String s = filterElement.getAttributeNS(null, "specularExponent");
/*     */     
/* 148 */     if (s.length() == 0) {
/* 149 */       return 1.0F;
/*     */     }
/*     */     try {
/* 152 */       float v = SVGUtilities.convertSVGNumber(s);
/* 153 */       if (v < 1.0F || v > 128.0F) {
/* 154 */         throw new BridgeException(ctx, filterElement, "attribute.malformed", new Object[] { "specularConstant", s });
/*     */       }
/*     */ 
/*     */       
/* 158 */       return v;
/*     */     } catch (NumberFormatException nfEx) {
/* 160 */       throw new BridgeException(ctx, filterElement, nfEx, "attribute.malformed", new Object[] { "specularConstant", s, nfEx });
/*     */     } 
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGFeSpecularLightingElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */