/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.RenderingHints;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import org.apache.batik.gvt.CompositeGraphicsNode;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.events.MutationEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGGElementBridge
/*     */   extends AbstractGraphicsNodeBridge
/*     */ {
/*  47 */   public String getLocalName() { return "g"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  54 */   public Bridge getInstance() { return new SVGGElementBridge(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GraphicsNode createGraphicsNode(BridgeContext ctx, Element e) {
/*  65 */     CompositeGraphicsNode gn = (CompositeGraphicsNode)super.createGraphicsNode(ctx, e);
/*     */     
/*  67 */     if (gn == null) {
/*  68 */       return null;
/*     */     }
/*  70 */     associateSVGContext(ctx, e, gn);
/*     */ 
/*     */     
/*  73 */     RenderingHints hints = null;
/*  74 */     hints = CSSUtilities.convertColorRendering(e, hints);
/*  75 */     if (hints != null) {
/*  76 */       gn.setRenderingHints(hints);
/*     */     }
/*     */     
/*  79 */     Rectangle2D r = CSSUtilities.convertEnableBackground(e);
/*  80 */     if (r != null) {
/*  81 */       gn.setBackgroundEnable(r);
/*     */     }
/*  83 */     return gn;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  90 */   protected GraphicsNode instantiateGraphicsNode() { return new CompositeGraphicsNode(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  97 */   public boolean isComposite() { return true; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMNodeInsertedEvent(MutationEvent evt) {
/* 106 */     if (evt.getTarget() instanceof Element) {
/* 107 */       handleElementAdded((CompositeGraphicsNode)this.node, this.e, (Element)evt.getTarget());
/*     */     }
/*     */     else {
/*     */       
/* 111 */       super.handleDOMNodeInsertedEvent(evt);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void handleElementAdded(CompositeGraphicsNode gn, Node parent, Element childElt) {
/* 122 */     GVTBuilder builder = this.ctx.getGVTBuilder();
/* 123 */     GraphicsNode childNode = builder.build(this.ctx, childElt);
/* 124 */     if (childNode == null) {
/*     */       return;
/*     */     }
/*     */ 
/*     */     
/* 129 */     int idx = -1;
/* 130 */     for (Node ps = childElt.getPreviousSibling(); ps != null; 
/* 131 */       ps = ps.getPreviousSibling()) {
/* 132 */       if (ps.getNodeType() != 1)
/*     */         continue; 
/* 134 */       Element pse = (Element)ps;
/* 135 */       CompositeGraphicsNode compositeGraphicsNode = this.ctx.getGraphicsNode(pse);
/* 136 */       while (compositeGraphicsNode != null && compositeGraphicsNode.getParent() != gn)
/*     */       {
/*     */         
/* 139 */         compositeGraphicsNode = compositeGraphicsNode.getParent();
/*     */       }
/* 141 */       if (compositeGraphicsNode == null)
/*     */         continue; 
/* 143 */       idx = gn.indexOf(compositeGraphicsNode);
/* 144 */       if (idx == -1) {
/*     */         continue;
/*     */       }
/*     */       
/*     */       break;
/*     */     } 
/* 150 */     idx++;
/* 151 */     gn.add(idx, childNode);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGGElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */