/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.StringTokenizer;
/*     */ import org.apache.batik.gvt.font.Kern;
/*     */ import org.apache.batik.gvt.font.UnicodeRange;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class SVGKernElementBridge
/*     */   extends AbstractSVGBridge
/*     */ {
/*     */   public Kern createKern(BridgeContext ctx, Element kernElement, SVGGVTFont font) {
/*     */     int[] arrayOfInt2, arrayOfInt1;
/*  52 */     String u1 = kernElement.getAttributeNS(null, "u1");
/*  53 */     String u2 = kernElement.getAttributeNS(null, "u2");
/*  54 */     String g1 = kernElement.getAttributeNS(null, "g1");
/*  55 */     String g2 = kernElement.getAttributeNS(null, "g2");
/*  56 */     String k = kernElement.getAttributeNS(null, "k");
/*  57 */     if (k.length() == 0) {
/*  58 */       k = "0";
/*     */     }
/*     */ 
/*     */     
/*  62 */     float kernValue = Float.parseFloat(k);
/*     */ 
/*     */     
/*  65 */     int firstGlyphLen = 0, secondGlyphLen = 0;
/*  66 */     int[] firstGlyphSet = null;
/*  67 */     int[] secondGlyphSet = null;
/*  68 */     List firstUnicodeRanges = new ArrayList();
/*  69 */     List secondUnicodeRanges = new ArrayList();
/*     */ 
/*     */     
/*  72 */     StringTokenizer st = new StringTokenizer(u1, ",");
/*  73 */     while (st.hasMoreTokens()) {
/*  74 */       arrayOfInt1 = st.nextToken();
/*  75 */       if (arrayOfInt1.startsWith("U+")) {
/*  76 */         firstUnicodeRanges.add(new UnicodeRange(arrayOfInt1)); continue;
/*     */       } 
/*  78 */       arrayOfInt2 = font.getGlyphCodesForUnicode(arrayOfInt1);
/*  79 */       if (firstGlyphSet == null) {
/*  80 */         firstGlyphSet = arrayOfInt2;
/*  81 */         firstGlyphLen = arrayOfInt2.length; continue;
/*     */       } 
/*  83 */       if (firstGlyphLen + arrayOfInt2.length > firstGlyphSet.length) {
/*     */         
/*  85 */         int sz = firstGlyphSet.length * 2;
/*  86 */         if (sz < firstGlyphLen + arrayOfInt2.length)
/*  87 */           sz = firstGlyphLen + arrayOfInt2.length; 
/*  88 */         int[] tmp = new int[sz];
/*  89 */         System.arraycopy(firstGlyphSet, 0, tmp, 0, firstGlyphLen);
/*  90 */         firstGlyphSet = tmp;
/*     */       } 
/*  92 */       for (int i = 0; i < arrayOfInt2.length; i++) {
/*  93 */         firstGlyphSet[firstGlyphLen++] = arrayOfInt2[i];
/*     */       }
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/*  99 */     st = new StringTokenizer(u2, ",");
/* 100 */     while (st.hasMoreTokens()) {
/* 101 */       arrayOfInt1 = st.nextToken();
/* 102 */       if (arrayOfInt1.startsWith("U+")) {
/* 103 */         secondUnicodeRanges.add(new UnicodeRange(arrayOfInt1)); continue;
/*     */       } 
/* 105 */       arrayOfInt2 = font.getGlyphCodesForUnicode(arrayOfInt1);
/* 106 */       if (secondGlyphSet == null) {
/* 107 */         secondGlyphSet = arrayOfInt2;
/* 108 */         secondGlyphLen = arrayOfInt2.length; continue;
/*     */       } 
/* 110 */       if (secondGlyphLen + arrayOfInt2.length > secondGlyphSet.length) {
/*     */         
/* 112 */         int sz = secondGlyphSet.length * 2;
/* 113 */         if (sz < secondGlyphLen + arrayOfInt2.length)
/* 114 */           sz = secondGlyphLen + arrayOfInt2.length; 
/* 115 */         int[] tmp = new int[sz];
/* 116 */         System.arraycopy(secondGlyphSet, 0, tmp, 0, secondGlyphLen);
/* 117 */         secondGlyphSet = tmp;
/*     */       } 
/* 119 */       for (int i = 0; i < arrayOfInt2.length; i++) {
/* 120 */         secondGlyphSet[secondGlyphLen++] = arrayOfInt2[i];
/*     */       }
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 126 */     st = new StringTokenizer(g1, ",");
/* 127 */     while (st.hasMoreTokens()) {
/* 128 */       arrayOfInt1 = st.nextToken();
/* 129 */       arrayOfInt2 = font.getGlyphCodesForName(arrayOfInt1);
/* 130 */       if (firstGlyphSet == null) {
/* 131 */         firstGlyphSet = arrayOfInt2;
/* 132 */         firstGlyphLen = arrayOfInt2.length; continue;
/*     */       } 
/* 134 */       if (firstGlyphLen + arrayOfInt2.length > firstGlyphSet.length) {
/*     */         
/* 136 */         int sz = firstGlyphSet.length * 2;
/* 137 */         if (sz < firstGlyphLen + arrayOfInt2.length)
/* 138 */           sz = firstGlyphLen + arrayOfInt2.length; 
/* 139 */         int[] tmp = new int[sz];
/* 140 */         System.arraycopy(firstGlyphSet, 0, tmp, 0, firstGlyphLen);
/* 141 */         firstGlyphSet = tmp;
/*     */       } 
/* 143 */       for (int i = 0; i < arrayOfInt2.length; i++) {
/* 144 */         firstGlyphSet[firstGlyphLen++] = arrayOfInt2[i];
/*     */       }
/*     */     } 
/*     */ 
/*     */     
/* 149 */     st = new StringTokenizer(g2, ",");
/* 150 */     while (st.hasMoreTokens()) {
/* 151 */       arrayOfInt1 = st.nextToken();
/* 152 */       arrayOfInt2 = font.getGlyphCodesForName(arrayOfInt1);
/* 153 */       if (secondGlyphSet == null) {
/* 154 */         secondGlyphSet = arrayOfInt2;
/* 155 */         secondGlyphLen = arrayOfInt2.length; continue;
/*     */       } 
/* 157 */       if (secondGlyphLen + arrayOfInt2.length > secondGlyphSet.length) {
/*     */         
/* 159 */         int sz = secondGlyphSet.length * 2;
/* 160 */         if (sz < secondGlyphLen + arrayOfInt2.length)
/* 161 */           sz = secondGlyphLen + arrayOfInt2.length; 
/* 162 */         int[] tmp = new int[sz];
/* 163 */         System.arraycopy(secondGlyphSet, 0, tmp, 0, secondGlyphLen);
/* 164 */         secondGlyphSet = tmp;
/*     */       } 
/* 166 */       for (int i = 0; i < arrayOfInt2.length; i++) {
/* 167 */         secondGlyphSet[secondGlyphLen++] = arrayOfInt2[i];
/*     */       }
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 173 */     if (firstGlyphLen == 0 || firstGlyphLen == firstGlyphSet.length) {
/*     */       
/* 175 */       arrayOfInt1 = firstGlyphSet;
/*     */     } else {
/* 177 */       arrayOfInt1 = new int[firstGlyphLen];
/* 178 */       System.arraycopy(firstGlyphSet, 0, arrayOfInt1, 0, firstGlyphLen);
/*     */     } 
/*     */     
/* 181 */     if (secondGlyphLen == 0 || secondGlyphLen == secondGlyphSet.length) {
/*     */       
/* 183 */       arrayOfInt2 = secondGlyphSet;
/*     */     } else {
/* 185 */       arrayOfInt2 = new int[secondGlyphLen];
/* 186 */       System.arraycopy(secondGlyphSet, 0, arrayOfInt2, 0, secondGlyphLen);
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 191 */     UnicodeRange[] firstRanges = new UnicodeRange[firstUnicodeRanges.size()];
/* 192 */     firstUnicodeRanges.toArray(firstRanges);
/*     */ 
/*     */     
/* 195 */     UnicodeRange[] secondRanges = new UnicodeRange[secondUnicodeRanges.size()];
/* 196 */     secondUnicodeRanges.toArray(secondRanges);
/*     */ 
/*     */     
/* 199 */     return new Kern(arrayOfInt1, arrayOfInt2, firstRanges, secondRanges, kernValue);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGKernElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */