/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import org.apache.batik.ext.awt.image.renderable.Filter;
/*     */ import org.apache.batik.gvt.CompositeGraphicsNode;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.apache.batik.gvt.filter.Mask;
/*     */ import org.apache.batik.gvt.filter.MaskRable8Bit;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGMaskElementBridge
/*     */   extends AnimatableGenericSVGBridge
/*     */   implements MaskBridge
/*     */ {
/*  50 */   public String getLocalName() { return "mask"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Mask createMask(BridgeContext ctx, Element maskElement, Element maskedElement, GraphicsNode maskedNode) {
/*     */     short s1;
/*     */     AffineTransform affineTransform;
/*  69 */     Rectangle2D maskRegion = SVGUtilities.convertMaskRegion(maskElement, maskedElement, maskedNode, ctx);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  75 */     GVTBuilder builder = ctx.getGVTBuilder();
/*  76 */     CompositeGraphicsNode maskNode = new CompositeGraphicsNode();
/*  77 */     CompositeGraphicsNode maskNodeContent = new CompositeGraphicsNode();
/*  78 */     maskNode.getChildren().add(maskNodeContent);
/*  79 */     boolean hasChildren = false;
/*  80 */     Node node = maskElement.getFirstChild();
/*  81 */     for (; node != null; 
/*  82 */       node = node.getNextSibling()) {
/*     */ 
/*     */       
/*  85 */       if (node.getNodeType() == 1) {
/*     */ 
/*     */ 
/*     */         
/*  89 */         affineTransform = (Element)node;
/*  90 */         GraphicsNode gn = builder.build(ctx, affineTransform);
/*  91 */         if (gn != null)
/*     */         
/*     */         { 
/*  94 */           hasChildren = true;
/*  95 */           maskNodeContent.getChildren().add(gn); } 
/*     */       } 
/*  97 */     }  if (!hasChildren) {
/*  98 */       return null;
/*     */     }
/*     */ 
/*     */ 
/*     */     
/* 103 */     String s = maskElement.getAttributeNS(null, "transform");
/* 104 */     if (s.length() != 0) {
/* 105 */       affineTransform = SVGUtilities.convertTransform(maskElement, "transform", s, ctx);
/*     */     } else {
/*     */       
/* 108 */       affineTransform = new AffineTransform();
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 113 */     s = maskElement.getAttributeNS(null, "maskContentUnits");
/* 114 */     if (s.length() == 0) {
/* 115 */       s1 = 1;
/*     */     } else {
/* 117 */       s1 = SVGUtilities.parseCoordinateSystem(maskElement, "maskContentUnits", s, ctx);
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 122 */     if (s1 == 2) {
/* 123 */       affineTransform = SVGUtilities.toObjectBBox(affineTransform, maskedNode);
/*     */     }
/*     */     
/* 126 */     maskNodeContent.setTransform(affineTransform);
/*     */     
/* 128 */     Filter filter = maskedNode.getFilter();
/* 129 */     if (filter == null)
/*     */     {
/* 131 */       filter = maskedNode.getGraphicsNodeRable(true);
/*     */     }
/*     */     
/* 134 */     return new MaskRable8Bit(filter, maskNode, maskRegion);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGMaskElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */