/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.Graphics2D;
/*     */ import java.awt.Paint;
/*     */ import java.awt.Shape;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.util.Iterator;
/*     */ import java.util.LinkedList;
/*     */ import java.util.List;
/*     */ import org.apache.batik.dom.svg.SVGOMDocument;
/*     */ import org.apache.batik.dom.util.XLinkSupport;
/*     */ import org.apache.batik.ext.awt.image.ConcreteComponentTransferFunction;
/*     */ import org.apache.batik.ext.awt.image.renderable.ComponentTransferRable8Bit;
/*     */ import org.apache.batik.ext.awt.image.renderable.Filter;
/*     */ import org.apache.batik.gvt.AbstractGraphicsNode;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.apache.batik.gvt.PatternPaint;
/*     */ import org.apache.batik.gvt.RootGraphicsNode;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVGPatternElementBridge
/*     */   extends AnimatableGenericSVGBridge
/*     */   implements PaintBridge, ErrorConstants
/*     */ {
/*  61 */   public String getLocalName() { return "pattern"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Paint createPaint(BridgeContext ctx, Element patternElement, Element paintedElement, GraphicsNode paintedNode, float opacity) {
/*     */     short s1;
/*     */     AffineTransform affineTransform;
/*  82 */     RootGraphicsNode patternContentNode = (RootGraphicsNode)ctx.getElementData(patternElement);
/*     */ 
/*     */     
/*  85 */     if (patternContentNode == null) {
/*  86 */       patternContentNode = extractPatternContent(patternElement, ctx);
/*  87 */       ctx.setElementData(patternElement, patternContentNode);
/*     */     } 
/*  89 */     if (patternContentNode == null) {
/*  90 */       return null;
/*     */     }
/*     */ 
/*     */ 
/*     */     
/*  95 */     Rectangle2D patternRegion = SVGUtilities.convertPatternRegion(patternElement, paintedElement, paintedNode, ctx);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 102 */     String s = SVGUtilities.getChainableAttributeNS(patternElement, null, "patternTransform", ctx);
/*     */     
/* 104 */     if (s.length() != 0) {
/* 105 */       affineTransform = SVGUtilities.convertTransform(patternElement, "patternTransform", s, ctx);
/*     */     } else {
/*     */       
/* 108 */       affineTransform = new AffineTransform();
/*     */     } 
/*     */ 
/*     */     
/* 112 */     boolean overflowIsHidden = CSSUtilities.convertOverflow(patternElement);
/*     */ 
/*     */ 
/*     */     
/* 116 */     s = SVGUtilities.getChainableAttributeNS(patternElement, null, "patternContentUnits", ctx);
/*     */     
/* 118 */     if (s.length() == 0) {
/* 119 */       s1 = 1;
/*     */     } else {
/* 121 */       s1 = SVGUtilities.parseCoordinateSystem(patternElement, "patternContentUnits", s, ctx);
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 150 */     AffineTransform patternContentTransform = new AffineTransform();
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 155 */     patternContentTransform.translate(patternRegion.getX(), patternRegion.getY());
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 163 */     String viewBoxStr = SVGUtilities.getChainableAttributeNS(patternElement, null, "viewBox", ctx);
/*     */ 
/*     */     
/* 166 */     if (viewBoxStr.length() > 0) {
/*     */ 
/*     */       
/* 169 */       String aspectRatioStr = SVGUtilities.getChainableAttributeNS(patternElement, null, "preserveAspectRatio", ctx);
/*     */       
/* 171 */       float w = (float)patternRegion.getWidth();
/* 172 */       float h = (float)patternRegion.getHeight();
/* 173 */       AffineTransform preserveAspectRatioTransform = ViewBox.getPreserveAspectRatioTransform(patternElement, viewBoxStr, aspectRatioStr, w, h, ctx);
/*     */ 
/*     */ 
/*     */       
/* 177 */       patternContentTransform.concatenate(preserveAspectRatioTransform);
/*     */ 
/*     */ 
/*     */     
/*     */     }
/* 182 */     else if (s1 == 2) {
/* 183 */       AffineTransform patternContentUnitsTransform = new AffineTransform();
/*     */       
/* 185 */       Rectangle2D objectBoundingBox = paintedNode.getGeometryBounds();
/*     */       
/* 187 */       patternContentUnitsTransform.translate(objectBoundingBox.getX(), objectBoundingBox.getY());
/*     */ 
/*     */ 
/*     */       
/* 191 */       patternContentUnitsTransform.scale(objectBoundingBox.getWidth(), objectBoundingBox.getHeight());
/*     */ 
/*     */ 
/*     */       
/* 195 */       patternContentTransform.concatenate(patternContentUnitsTransform);
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 205 */     PatternGraphicsNode patternGraphicsNode = new PatternGraphicsNode(patternContentNode);
/*     */     
/* 207 */     patternGraphicsNode.setTransform(patternContentTransform);
/*     */ 
/*     */     
/* 210 */     if (opacity != 1.0F) {
/* 211 */       Filter filter = patternGraphicsNode.getGraphicsNodeRable(true);
/* 212 */       ComponentTransferRable8Bit componentTransferRable8Bit = new ComponentTransferRable8Bit(filter, ConcreteComponentTransferFunction.getLinearTransfer(opacity, 0.0F), ConcreteComponentTransferFunction.getIdentityTransfer(), ConcreteComponentTransferFunction.getIdentityTransfer(), ConcreteComponentTransferFunction.getIdentityTransfer());
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 219 */       patternGraphicsNode.setFilter(componentTransferRable8Bit);
/*     */     } 
/*     */ 
/*     */ 
/*     */     
/* 224 */     return new PatternPaint(patternGraphicsNode, patternRegion, !overflowIsHidden, affineTransform);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static RootGraphicsNode extractPatternContent(Element patternElement, BridgeContext ctx) {
/* 244 */     List refs = new LinkedList();
/*     */     while (true) {
/* 246 */       RootGraphicsNode content = extractLocalPatternContent(patternElement, ctx);
/*     */       
/* 248 */       if (content != null) {
/* 249 */         return content;
/*     */       }
/* 251 */       String uri = XLinkSupport.getXLinkHref(patternElement);
/* 252 */       if (uri.length() == 0) {
/* 253 */         return null;
/*     */       }
/*     */       
/* 256 */       SVGOMDocument doc = (SVGOMDocument)patternElement.getOwnerDocument();
/*     */       
/* 258 */       ParsedURL purl = new ParsedURL(doc.getURL(), uri);
/* 259 */       if (!purl.complete()) {
/* 260 */         throw new BridgeException(ctx, patternElement, "uri.malformed", new Object[] { uri });
/*     */       }
/*     */ 
/*     */       
/* 264 */       if (contains(refs, purl)) {
/* 265 */         throw new BridgeException(ctx, patternElement, "xlink.href.circularDependencies", new Object[] { uri });
/*     */       }
/*     */ 
/*     */       
/* 269 */       refs.add(purl);
/* 270 */       patternElement = ctx.getReferencedElement(patternElement, uri);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static RootGraphicsNode extractLocalPatternContent(Element e, BridgeContext ctx) {
/* 284 */     GVTBuilder builder = ctx.getGVTBuilder();
/* 285 */     RootGraphicsNode content = null;
/* 286 */     for (Node n = e.getFirstChild(); n != null; n = n.getNextSibling()) {
/*     */       
/* 288 */       if (n.getNodeType() == 1) {
/*     */ 
/*     */ 
/*     */         
/* 292 */         GraphicsNode gn = builder.build(ctx, (Element)n);
/*     */         
/* 294 */         if (gn != null) {
/*     */           
/* 296 */           if (content == null) {
/* 297 */             content = new RootGraphicsNode();
/*     */           }
/* 299 */           content.getChildren().add(gn);
/*     */         } 
/*     */       } 
/* 302 */     }  return content;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private static boolean contains(List urls, ParsedURL key) {
/* 312 */     Iterator iter = urls.iterator();
/* 313 */     while (iter.hasNext()) {
/* 314 */       if (key.equals(iter.next()))
/* 315 */         return true; 
/*     */     } 
/* 317 */     return false;
/*     */   }
/*     */   
/*     */   public static class PatternGraphicsNode extends AbstractGraphicsNode {
/*     */     GraphicsNode pcn;
/*     */     Rectangle2D pBounds;
/*     */     Rectangle2D gBounds;
/*     */     Rectangle2D sBounds;
/*     */     Shape oShape;
/*     */     
/* 327 */     public PatternGraphicsNode(GraphicsNode gn) { this.pcn = gn; }
/*     */ 
/*     */     
/* 330 */     public void primitivePaint(Graphics2D g2d) { this.pcn.paint(g2d); }
/*     */     
/*     */     public Rectangle2D getPrimitiveBounds() {
/* 333 */       if (this.pBounds != null) return this.pBounds; 
/* 334 */       this.pBounds = this.pcn.getTransformedBounds(GraphicsNode.IDENTITY);
/* 335 */       return this.pBounds;
/*     */     }
/*     */     public Rectangle2D getGeometryBounds() {
/* 338 */       if (this.gBounds != null) return this.gBounds; 
/* 339 */       this.gBounds = this.pcn.getTransformedGeometryBounds(GraphicsNode.IDENTITY);
/* 340 */       return this.gBounds;
/*     */     }
/*     */     public Rectangle2D getSensitiveBounds() {
/* 343 */       if (this.sBounds != null) return this.sBounds; 
/* 344 */       this.sBounds = this.pcn.getTransformedSensitiveBounds(GraphicsNode.IDENTITY);
/* 345 */       return this.sBounds;
/*     */     }
/*     */     public Shape getOutline() {
/* 348 */       if (this.oShape != null) return this.oShape; 
/* 349 */       this.oShape = this.pcn.getOutline();
/* 350 */       AffineTransform tr = this.pcn.getTransform();
/* 351 */       if (tr != null)
/* 352 */         this.oShape = tr.createTransformedShape(this.oShape); 
/* 353 */       return this.oShape;
/*     */     }
/*     */     protected void invalidateGeometryCache() {
/* 356 */       this.pBounds = null;
/* 357 */       this.gBounds = null;
/* 358 */       this.sBounds = null;
/* 359 */       this.oShape = null;
/* 360 */       super.invalidateGeometryCache();
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGPatternElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */