/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.font.TextAttribute;
/*     */ import java.util.ArrayList;
/*     */ import java.util.StringTokenizer;
/*     */ import org.apache.batik.css.engine.value.Value;
/*     */ import org.apache.batik.gvt.TextNode;
/*     */ import org.apache.batik.parser.UnitProcessor;
/*     */ import org.apache.batik.util.CSSConstants;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class TextUtilities
/*     */   implements CSSConstants, ErrorConstants
/*     */ {
/*     */   public static String getElementContent(Element e) {
/*  46 */     StringBuffer result = new StringBuffer();
/*  47 */     Node n = e.getFirstChild();
/*  48 */     for (; n != null; 
/*  49 */       n = n.getNextSibling()) {
/*  50 */       switch (n.getNodeType()) {
/*     */         case 1:
/*  52 */           result.append(getElementContent((Element)n));
/*     */           break;
/*     */         case 3:
/*     */         case 4:
/*  56 */           result.append(n.getNodeValue()); break;
/*     */       } 
/*     */     } 
/*  59 */     return result.toString();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static ArrayList svgHorizontalCoordinateArrayToUserSpace(Element element, String attrName, String valueStr, BridgeContext ctx) {
/*  77 */     UnitProcessor.Context uctx = UnitProcessor.createContext(ctx, element);
/*  78 */     ArrayList values = new ArrayList();
/*  79 */     StringTokenizer st = new StringTokenizer(valueStr, ", ", false);
/*  80 */     while (st.hasMoreTokens()) {
/*  81 */       values.add(new Float(UnitProcessor.svgHorizontalCoordinateToUserSpace(st.nextToken(), attrName, uctx)));
/*     */     }
/*     */ 
/*     */     
/*  85 */     return values;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static ArrayList svgVerticalCoordinateArrayToUserSpace(Element element, String attrName, String valueStr, BridgeContext ctx) {
/* 103 */     UnitProcessor.Context uctx = UnitProcessor.createContext(ctx, element);
/* 104 */     ArrayList values = new ArrayList();
/* 105 */     StringTokenizer st = new StringTokenizer(valueStr, ", ", false);
/* 106 */     while (st.hasMoreTokens()) {
/* 107 */       values.add(new Float(UnitProcessor.svgVerticalCoordinateToUserSpace(st.nextToken(), attrName, uctx)));
/*     */     }
/*     */ 
/*     */     
/* 111 */     return values;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static ArrayList svgRotateArrayToFloats(Element element, String attrName, String valueStr, BridgeContext ctx) {
/* 120 */     StringTokenizer st = new StringTokenizer(valueStr, ", ", false);
/* 121 */     ArrayList values = new ArrayList();
/*     */     
/* 123 */     while (st.hasMoreTokens()) {
/*     */       try {
/* 125 */         String s = st.nextToken();
/* 126 */         values.add(new Float(Math.toRadians(SVGUtilities.convertSVGNumber(s))));
/*     */       }
/*     */       catch (NumberFormatException nfEx) {
/*     */         
/* 130 */         throw new BridgeException(ctx, element, nfEx, "attribute.malformed", new Object[] { attrName, valueStr });
/*     */       } 
/*     */     } 
/*     */ 
/*     */     
/* 135 */     return values;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertFontSize(Element e) {
/* 143 */     Value v = CSSUtilities.getComputedStyle(e, 22);
/*     */     
/* 145 */     return new Float(v.getFloatValue());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertFontStyle(Element e) {
/* 153 */     Value v = CSSUtilities.getComputedStyle(e, 25);
/*     */     
/* 155 */     switch (v.getStringValue().charAt(0)) {
/*     */       case 'n':
/* 157 */         return TextAttribute.POSTURE_REGULAR;
/*     */     } 
/* 159 */     return TextAttribute.POSTURE_OBLIQUE;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertFontStretch(Element e) {
/* 168 */     Value v = CSSUtilities.getComputedStyle(e, 24);
/*     */     
/* 170 */     String s = v.getStringValue();
/* 171 */     switch (s.charAt(0)) {
/*     */       case 'u':
/* 173 */         if (s.charAt(6) == 'c') {
/* 174 */           return TextAttribute.WIDTH_CONDENSED;
/*     */         }
/* 176 */         return TextAttribute.WIDTH_EXTENDED;
/*     */ 
/*     */       
/*     */       case 'e':
/* 180 */         if (s.charAt(6) == 'c') {
/* 181 */           return TextAttribute.WIDTH_CONDENSED;
/*     */         }
/* 183 */         if (s.length() == 8) {
/* 184 */           return TextAttribute.WIDTH_SEMI_EXTENDED;
/*     */         }
/* 186 */         return TextAttribute.WIDTH_EXTENDED;
/*     */ 
/*     */ 
/*     */       
/*     */       case 's':
/* 191 */         if (s.charAt(6) == 'c') {
/* 192 */           return TextAttribute.WIDTH_SEMI_CONDENSED;
/*     */         }
/* 194 */         return TextAttribute.WIDTH_SEMI_EXTENDED;
/*     */     } 
/*     */ 
/*     */     
/* 198 */     return TextAttribute.WIDTH_REGULAR;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertFontWeight(Element e) {
/* 207 */     Value v = CSSUtilities.getComputedStyle(e, 27);
/*     */     
/* 209 */     float f = v.getFloatValue();
/* 210 */     switch ((int)f) {
/*     */       case 100:
/* 212 */         return TextAttribute.WEIGHT_EXTRA_LIGHT;
/*     */       case 200:
/* 214 */         return TextAttribute.WEIGHT_LIGHT;
/*     */       case 300:
/* 216 */         return TextAttribute.WEIGHT_DEMILIGHT;
/*     */       case 400:
/* 218 */         return TextAttribute.WEIGHT_REGULAR;
/*     */       case 500:
/* 220 */         return TextAttribute.WEIGHT_SEMIBOLD;
/*     */     } 
/* 222 */     return TextAttribute.WEIGHT_BOLD;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static TextNode.Anchor convertTextAnchor(Element e) {
/* 241 */     Value v = CSSUtilities.getComputedStyle(e, 53);
/*     */     
/* 243 */     switch (v.getStringValue().charAt(0)) {
/*     */       case 's':
/* 245 */         return TextNode.Anchor.START;
/*     */       case 'm':
/* 247 */         return TextNode.Anchor.MIDDLE;
/*     */     } 
/* 249 */     return TextNode.Anchor.END;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Object convertBaselineShift(Element e) {
/* 259 */     Value v = CSSUtilities.getComputedStyle(e, 1);
/*     */     
/* 261 */     if (v.getPrimitiveType() == 21) {
/* 262 */       String s = v.getStringValue();
/* 263 */       switch (s.charAt(2)) {
/*     */         case 'p':
/* 265 */           return TextAttribute.SUPERSCRIPT_SUPER;
/*     */         
/*     */         case 'b':
/* 268 */           return TextAttribute.SUPERSCRIPT_SUB;
/*     */       } 
/*     */       
/* 271 */       return null;
/*     */     } 
/*     */     
/* 274 */     return new Float(v.getFloatValue());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertKerning(Element e) {
/* 284 */     Value v = CSSUtilities.getComputedStyle(e, 31);
/*     */     
/* 286 */     if (v.getPrimitiveType() == 21) {
/* 287 */       return null;
/*     */     }
/* 289 */     return new Float(v.getFloatValue());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertLetterSpacing(Element e) {
/* 298 */     Value v = CSSUtilities.getComputedStyle(e, 32);
/*     */     
/* 300 */     if (v.getPrimitiveType() == 21) {
/* 301 */       return null;
/*     */     }
/* 303 */     return new Float(v.getFloatValue());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Float convertWordSpacing(Element e) {
/* 312 */     Value v = CSSUtilities.getComputedStyle(e, 58);
/*     */     
/* 314 */     if (v.getPrimitiveType() == 21) {
/* 315 */       return null;
/*     */     }
/* 317 */     return new Float(v.getFloatValue());
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\TextUtilities.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */