/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import org.apache.batik.parser.ParseException;
/*     */ import org.apache.batik.parser.UnitProcessor;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class UnitProcessor
/*     */   extends UnitProcessor
/*     */ {
/*  44 */   public static UnitProcessor.Context createContext(BridgeContext ctx, Element e) { return new DefaultContext(ctx, e); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  63 */   public static float svgHorizontalCoordinateToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgToObjectBoundingBox(s, attr, (short)2, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  78 */   public static float svgVerticalCoordinateToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgToObjectBoundingBox(s, attr, (short)1, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  93 */   public static float svgOtherCoordinateToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgToObjectBoundingBox(s, attr, (short)0, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 108 */   public static float svgHorizontalLengthToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToObjectBoundingBox(s, attr, (short)2, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 123 */   public static float svgVerticalLengthToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToObjectBoundingBox(s, attr, (short)1, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 138 */   public static float svgOtherLengthToObjectBoundingBox(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToObjectBoundingBox(s, attr, (short)0, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float svgLengthToObjectBoundingBox(String s, String attr, short d, UnitProcessor.Context ctx) {
/* 154 */     float v = svgToObjectBoundingBox(s, attr, d, ctx);
/* 155 */     if (v < 0.0F) {
/* 156 */       throw new BridgeException(getBridgeContext(ctx), ctx.getElement(), "length.negative", new Object[] { attr, s });
/*     */     }
/*     */ 
/*     */     
/* 160 */     return v;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float svgToObjectBoundingBox(String s, String attr, short d, UnitProcessor.Context ctx) {
/*     */     try {
/* 177 */       return UnitProcessor.svgToObjectBoundingBox(s, attr, d, ctx);
/*     */     } catch (ParseException pEx) {
/*     */       
/* 180 */       throw new BridgeException(getBridgeContext(ctx), ctx.getElement(), pEx, "attribute.malformed", new Object[] { attr, s, pEx });
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 203 */   public static float svgHorizontalLengthToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToUserSpace(s, attr, (short)2, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 217 */   public static float svgVerticalLengthToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToUserSpace(s, attr, (short)1, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 231 */   public static float svgOtherLengthToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgLengthToUserSpace(s, attr, (short)0, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 244 */   public static float svgHorizontalCoordinateToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgToUserSpace(s, attr, (short)2, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 257 */   public static float svgVerticalCoordinateToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgToUserSpace(s, attr, (short)1, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 270 */   public static float svgOtherCoordinateToUserSpace(String s, String attr, UnitProcessor.Context ctx) { return svgToUserSpace(s, attr, (short)0, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float svgLengthToUserSpace(String s, String attr, short d, UnitProcessor.Context ctx) {
/* 286 */     float v = svgToUserSpace(s, attr, d, ctx);
/* 287 */     if (v < 0.0F) {
/* 288 */       throw new BridgeException(getBridgeContext(ctx), ctx.getElement(), "length.negative", new Object[] { attr, s });
/*     */     }
/*     */ 
/*     */     
/* 292 */     return v;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float svgToUserSpace(String s, String attr, short d, UnitProcessor.Context ctx) {
/*     */     try {
/* 310 */       return UnitProcessor.svgToUserSpace(s, attr, d, ctx);
/*     */     } catch (ParseException pEx) {
/*     */       
/* 313 */       throw new BridgeException(getBridgeContext(ctx), ctx.getElement(), pEx, "attribute.malformed", new Object[] { attr, s, pEx });
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static BridgeContext getBridgeContext(UnitProcessor.Context ctx) {
/* 325 */     if (ctx instanceof DefaultContext) {
/* 326 */       return ((DefaultContext)ctx).ctx;
/*     */     }
/* 328 */     return null;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static class DefaultContext
/*     */     implements UnitProcessor.Context
/*     */   {
/*     */     protected Element e;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     protected BridgeContext ctx;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public DefaultContext(BridgeContext ctx, Element e) {
/* 352 */       this.ctx = ctx;
/* 353 */       this.e = e;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 360 */     public Element getElement() { return this.e; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 367 */     public float getPixelUnitToMillimeter() { return this.ctx.getUserAgent().getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 376 */     public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 384 */     public float getFontSize() { return CSSUtilities.getComputedStyle(this.e, 22).getFloatValue(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 392 */     public float getXHeight() { return 0.5F; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 399 */     public float getViewportWidth() { return this.ctx.getViewport(this.e).getWidth(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 406 */     public float getViewportHeight() { return this.ctx.getViewport(this.e).getHeight(); }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\UnitProcessor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */