/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.Cursor;
/*     */ import java.awt.Dimension;
/*     */ import java.awt.Point;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Dimension2D;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.Set;
/*     */ import org.apache.batik.gvt.event.EventDispatcher;
/*     */ import org.apache.batik.gvt.text.Mark;
/*     */ import org.apache.batik.util.ParsedURL;
/*     */ import org.apache.batik.util.SVGFeatureStrings;
/*     */ import org.apache.batik.util.XMLResourceDescriptor;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.svg.SVGAElement;
/*     */ import org.w3c.dom.svg.SVGDocument;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class UserAgentAdapter
/*     */   implements UserAgent
/*     */ {
/*  48 */   protected Set FEATURES = new HashSet();
/*  49 */   protected Set extensions = new HashSet();
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected BridgeContext ctx;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  60 */   public void setBridgeContext(BridgeContext ctx) { this.ctx = ctx; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  68 */   public void addStdFeatures() { SVGFeatureStrings.addSupportedFeatureStrings(this.FEATURES); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  75 */   public Dimension2D getViewportSize() { return new Dimension(1, 1); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void displayMessage(String message) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  88 */   public void displayError(String message) { displayMessage(message); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  95 */   public void displayError(Exception e) { displayError(e.getMessage()); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void showAlert(String message) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 108 */   public String showPrompt(String message) { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 115 */   public String showPrompt(String message, String defaultValue) { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 122 */   public boolean showConfirm(String message) { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 129 */   public float getPixelUnitToMillimeter() { return 0.26458332F; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 138 */   public float getPixelToMM() { return getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 146 */   public String getDefaultFontFamily() { return "Arial, Helvetica, sans-serif"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 154 */   public float getMediumFontSize() { return 228.59999F / 72.0F * getPixelUnitToMillimeter(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 161 */   public float getLighterFontWeight(float f) { return getStandardLighterFontWeight(f); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 168 */   public float getBolderFontWeight(float f) { return getStandardBolderFontWeight(f); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 176 */   public String getLanguages() { return "en"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 183 */   public String getMedia() { return "all"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 190 */   public String getAlternateStyleSheet() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 197 */   public String getUserStyleSheetURI() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 204 */   public String getXMLParserClassName() { return XMLResourceDescriptor.getXMLParserClassName(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 211 */   public boolean isXMLParserValidating() { return false; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 218 */   public EventDispatcher getEventDispatcher() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void openLink(SVGAElement elt) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setSVGCursor(Cursor cursor) {}
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setTextSelection(Mark start, Mark end) {}
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void deselectAll() {}
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void runThread(Thread t) {}
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 250 */   public AffineTransform getTransform() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setTransform(AffineTransform at) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 264 */   public Point getClientAreaLocationOnScreen() { return new Point(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 272 */   public boolean hasFeature(String s) { return this.FEATURES.contains(s); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 280 */   public boolean supportExtension(String s) { return this.extensions.contains(s); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void registerExtension(BridgeExtension ext) {
/* 288 */     Iterator i = ext.getImplementedExtensions();
/* 289 */     while (i.hasNext()) {
/* 290 */       this.extensions.add(i.next());
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleElement(Element elt, Object data) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 320 */   public ScriptSecurity getScriptSecurity(String scriptType, ParsedURL scriptURL, ParsedURL docURL) { return new DefaultScriptSecurity(scriptType, scriptURL, docURL); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void checkLoadScript(String scriptType, ParsedURL scriptURL, ParsedURL docURL) throws SecurityException {
/* 344 */     ScriptSecurity s = getScriptSecurity(scriptType, scriptURL, docURL);
/*     */ 
/*     */     
/* 347 */     if (s != null) {
/* 348 */       s.checkLoadScript();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 366 */   public ExternalResourceSecurity getExternalResourceSecurity(ParsedURL resourceURL, ParsedURL docURL) { return new RelaxedExternalResourceSecurity(resourceURL, docURL); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void checkLoadExternalResource(ParsedURL resourceURL, ParsedURL docURL) throws SecurityException {
/* 388 */     ExternalResourceSecurity s = getExternalResourceSecurity(resourceURL, docURL);
/*     */ 
/*     */     
/* 391 */     if (s != null) {
/* 392 */       s.checkLoadExternalResource();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float getStandardLighterFontWeight(float f) {
/* 401 */     int weight = (int)((f + 50.0F) / 100.0F) * 100;
/* 402 */     switch (weight) { case 100:
/* 403 */         return 100.0F;
/* 404 */       case 200: return 100.0F;
/* 405 */       case 300: return 200.0F;
/* 406 */       case 400: return 300.0F;
/* 407 */       case 500: return 400.0F;
/* 408 */       case 600: return 400.0F;
/* 409 */       case 700: return 400.0F;
/* 410 */       case 800: return 400.0F;
/* 411 */       case 900: return 400.0F; }
/*     */     
/* 413 */     throw new IllegalArgumentException("Bad Font Weight: " + f);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static float getStandardBolderFontWeight(float f) {
/* 422 */     int weight = (int)((f + 50.0F) / 100.0F) * 100;
/* 423 */     switch (weight) { case 100:
/* 424 */         return 600.0F;
/* 425 */       case 200: return 600.0F;
/* 426 */       case 300: return 600.0F;
/* 427 */       case 400: return 600.0F;
/* 428 */       case 500: return 600.0F;
/* 429 */       case 600: return 700.0F;
/* 430 */       case 700: return 800.0F;
/* 431 */       case 800: return 900.0F;
/* 432 */       case 900: return 900.0F; }
/*     */     
/* 434 */     throw new IllegalArgumentException("Bad Font Weight: " + f);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 449 */   public SVGDocument getBrokenLinkDocument(Element e, String url, String message) { throw new BridgeException(this.ctx, e, "uri.image.broken", new Object[] { url, message }); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\UserAgentAdapter.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */