/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import java.util.HashMap;
/*     */ import org.apache.batik.dom.svg12.XBLOMContentElement;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AbstractContentSelector
/*     */ {
/*     */   protected ContentManager contentManager;
/*     */   protected XBLOMContentElement contentElement;
/*     */   protected Element boundElement;
/*     */   
/*     */   public AbstractContentSelector(ContentManager cm, XBLOMContentElement content, Element bound) {
/*  59 */     this.contentManager = cm;
/*  60 */     this.contentElement = content;
/*  61 */     this.boundElement = bound;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  83 */   protected boolean isSelected(Node n) { return (this.contentManager.getContentElement(n) != null); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  89 */   protected static HashMap selectorFactories = new HashMap();
/*     */   static  {
/*  91 */     f1 = new XPathPatternContentSelectorFactory();
/*  92 */     ContentSelectorFactory f2 = new XPathSubsetContentSelectorFactory();
/*  93 */     selectorFactories.put(null, f1);
/*  94 */     selectorFactories.put("XPathPattern", f1);
/*  95 */     selectorFactories.put("XPathSubset", f2);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static AbstractContentSelector createSelector(String selectorLanguage, ContentManager cm, XBLOMContentElement content, Element bound, String selector) {
/* 111 */     ContentSelectorFactory f = (ContentSelectorFactory)selectorFactories.get(selectorLanguage);
/*     */     
/* 113 */     if (f == null) {
/* 114 */       throw new RuntimeException("Invalid XBL content selector language '" + selectorLanguage + "'");
/*     */     }
/*     */ 
/*     */ 
/*     */     
/* 119 */     return f.createSelector(cm, content, bound, selector);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public abstract NodeList getSelectedContent();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   abstract boolean update();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static interface ContentSelectorFactory
/*     */   {
/*     */     AbstractContentSelector createSelector(ContentManager param1ContentManager, XBLOMContentElement param1XBLOMContentElement, Element param1Element, String param1String);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class XPathSubsetContentSelectorFactory
/*     */     implements ContentSelectorFactory
/*     */   {
/* 149 */     public AbstractContentSelector createSelector(ContentManager cm, XBLOMContentElement content, Element bound, String selector) { return new XPathSubsetContentSelector(cm, content, bound, selector); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class XPathPatternContentSelectorFactory
/*     */     implements ContentSelectorFactory
/*     */   {
/* 166 */     public AbstractContentSelector createSelector(ContentManager cm, XBLOMContentElement content, Element bound, String selector) { return new XPathPatternContentSelector(cm, content, bound, selector); }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\AbstractContentSelector.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */