/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import java.util.Iterator;
/*     */ import org.apache.batik.bridge.BridgeContext;
/*     */ import org.apache.batik.bridge.BridgeUpdateHandler;
/*     */ import org.apache.batik.bridge.DocumentLoader;
/*     */ import org.apache.batik.bridge.ScriptingEnvironment;
/*     */ import org.apache.batik.bridge.URIResolver;
/*     */ import org.apache.batik.bridge.UserAgent;
/*     */ import org.apache.batik.css.engine.CSSEngine;
/*     */ import org.apache.batik.dom.AbstractDocument;
/*     */ import org.apache.batik.dom.AbstractNode;
/*     */ import org.apache.batik.dom.events.EventSupport;
/*     */ import org.apache.batik.dom.events.NodeEventTarget;
/*     */ import org.apache.batik.dom.svg.SVGOMDocument;
/*     */ import org.apache.batik.dom.svg12.XBLEventSupport;
/*     */ import org.apache.batik.dom.xbl.NodeXBL;
/*     */ import org.apache.batik.dom.xbl.XBLManager;
/*     */ import org.apache.batik.script.Interpreter;
/*     */ import org.apache.batik.script.InterpreterPool;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.events.Event;
/*     */ import org.w3c.dom.events.EventListener;
/*     */ import org.w3c.dom.events.EventTarget;
/*     */ import org.w3c.dom.svg.SVGDocument;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVG12BridgeContext
/*     */   extends BridgeContext
/*     */ {
/*     */   protected XBLBindingListener bindingListener;
/*     */   protected XBLContentListener contentListener;
/*     */   protected EventTarget mouseCaptureTarget;
/*     */   protected boolean mouseCaptureSendAll;
/*     */   protected boolean mouseCaptureAutoRelease;
/*     */   
/*  92 */   public SVG12BridgeContext(UserAgent userAgent) { super(userAgent); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 102 */   public SVG12BridgeContext(UserAgent userAgent, DocumentLoader loader) { super(userAgent, loader); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 114 */   public SVG12BridgeContext(UserAgent userAgent, InterpreterPool interpreterPool, DocumentLoader documentLoader) { super(userAgent, interpreterPool, documentLoader); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 121 */   public URIResolver createURIResolver(SVGDocument doc, DocumentLoader dl) { return new SVG12URIResolver(doc, dl); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 128 */   public void addGVTListener(Document doc) { SVG12BridgeEventSupport.addGVTListener(this, doc); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispose() {
/* 135 */     clearChildContexts();
/*     */     
/* 137 */     synchronized (this.eventListenerSet) {
/*     */       
/* 139 */       Iterator iter = this.eventListenerSet.iterator();
/* 140 */       while (iter.hasNext()) {
/* 141 */         BridgeContext.EventListenerMememto m = (BridgeContext.EventListenerMememto)iter.next();
/* 142 */         NodeEventTarget et = m.getTarget();
/* 143 */         EventListener el = m.getListener();
/* 144 */         boolean uc = m.getUseCapture();
/* 145 */         String t = m.getEventType();
/* 146 */         boolean in = m.getNamespaced();
/* 147 */         if (et == null || el == null || t == null) {
/*     */           continue;
/*     */         }
/* 150 */         if (m instanceof ImplementationEventListenerMememto) {
/* 151 */           String ns = m.getNamespaceURI();
/* 152 */           Node nde = (Node)et;
/* 153 */           AbstractNode n = (AbstractNode)nde.getOwnerDocument();
/* 154 */           if (n != null) {
/*     */             
/* 156 */             XBLEventSupport es = (XBLEventSupport)n.initializeEventSupport();
/* 157 */             es.removeImplementationEventListenerNS(ns, t, el, uc);
/*     */           }  continue;
/* 159 */         }  if (in) {
/* 160 */           String ns = m.getNamespaceURI();
/* 161 */           et.removeEventListenerNS(ns, t, el, uc); continue;
/*     */         } 
/* 163 */         et.removeEventListener(t, el, uc);
/*     */       } 
/*     */     } 
/*     */ 
/*     */     
/* 168 */     if (this.document != null) {
/* 169 */       removeDOMListeners();
/* 170 */       removeBindingListener();
/*     */     } 
/*     */     
/* 173 */     if (this.animationEngine != null) {
/* 174 */       this.animationEngine.dispose();
/* 175 */       this.animationEngine = null;
/*     */     } 
/*     */     
/* 178 */     Iterator iter = this.interpreterMap.values().iterator();
/* 179 */     while (iter.hasNext()) {
/* 180 */       Interpreter interpreter = (Interpreter)iter.next();
/* 181 */       if (interpreter != null)
/* 182 */         interpreter.dispose(); 
/*     */     } 
/* 184 */     this.interpreterMap.clear();
/*     */     
/* 186 */     if (this.focusManager != null) {
/* 187 */       this.focusManager.dispose();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addBindingListener() {
/* 196 */     AbstractDocument doc = (AbstractDocument)this.document;
/* 197 */     DefaultXBLManager xm = (DefaultXBLManager)doc.getXBLManager();
/* 198 */     if (xm != null) {
/* 199 */       this.bindingListener = new XBLBindingListener(this);
/* 200 */       xm.addBindingListener(this.bindingListener);
/* 201 */       this.contentListener = new XBLContentListener(this);
/* 202 */       xm.addContentSelectionChangedListener(this.contentListener);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void removeBindingListener() {
/* 210 */     AbstractDocument doc = (AbstractDocument)this.document;
/* 211 */     XBLManager xm = doc.getXBLManager();
/* 212 */     if (xm instanceof DefaultXBLManager) {
/* 213 */       DefaultXBLManager dxm = (DefaultXBLManager)xm;
/* 214 */       dxm.removeBindingListener(this.bindingListener);
/* 215 */       dxm.removeContentSelectionChangedListener(this.contentListener);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addDOMListeners() {
/* 227 */     SVGOMDocument doc = (SVGOMDocument)this.document;
/* 228 */     XBLEventSupport evtSupport = (XBLEventSupport)doc.initializeEventSupport();
/*     */ 
/*     */     
/* 231 */     this.domAttrModifiedEventListener = new EventListenerWrapper(this, new BridgeContext.DOMAttrModifiedEventListener(this));
/*     */     
/* 233 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMAttrModified", this.domAttrModifiedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 238 */     this.domNodeInsertedEventListener = new EventListenerWrapper(this, new BridgeContext.DOMNodeInsertedEventListener(this));
/*     */     
/* 240 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeInserted", this.domNodeInsertedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 245 */     this.domNodeRemovedEventListener = new EventListenerWrapper(this, new BridgeContext.DOMNodeRemovedEventListener(this));
/*     */     
/* 247 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeRemoved", this.domNodeRemovedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 252 */     this.domCharacterDataModifiedEventListener = new EventListenerWrapper(this, new BridgeContext.DOMCharacterDataModifiedEventListener(this));
/*     */     
/* 254 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMCharacterDataModified", this.domCharacterDataModifiedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 259 */     this.animatedAttributeListener = new BridgeContext.AnimatedAttrListener(this);
/* 260 */     doc.addAnimatedAttributeListener(this.animatedAttributeListener);
/*     */     
/* 262 */     this.focusManager = new SVG12FocusManager(this.document);
/*     */     
/* 264 */     CSSEngine cssEngine = doc.getCSSEngine();
/* 265 */     this.cssPropertiesChangedListener = new BridgeContext.CSSPropertiesChangedListener(this);
/* 266 */     cssEngine.addCSSEngineListener(this.cssPropertiesChangedListener);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addUIEventListeners(Document doc) {
/* 282 */     EventTarget evtTarget = (EventTarget)doc.getDocumentElement();
/* 283 */     AbstractNode n = (AbstractNode)evtTarget;
/* 284 */     XBLEventSupport evtSupport = (XBLEventSupport)n.initializeEventSupport();
/*     */ 
/*     */     
/* 287 */     EventListener domMouseOverListener = new EventListenerWrapper(this, new BridgeContext.DOMMouseOverEventListener(this));
/*     */     
/* 289 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseover", domMouseOverListener, true);
/*     */ 
/*     */ 
/*     */     
/* 293 */     storeImplementationEventListenerNS(evtTarget, "http://www.w3.org/2001/xml-events", "mouseover", domMouseOverListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 299 */     EventListener domMouseOutListener = new EventListenerWrapper(this, new BridgeContext.DOMMouseOutEventListener(this));
/*     */     
/* 301 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseout", domMouseOutListener, true);
/*     */ 
/*     */ 
/*     */     
/* 305 */     storeImplementationEventListenerNS(evtTarget, "http://www.w3.org/2001/xml-events", "mouseout", domMouseOutListener, true);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void removeUIEventListeners(Document doc) {
/* 313 */     EventTarget evtTarget = (EventTarget)doc.getDocumentElement();
/* 314 */     AbstractNode n = (AbstractNode)evtTarget;
/* 315 */     XBLEventSupport es = (XBLEventSupport)n.initializeEventSupport();
/*     */     
/* 317 */     synchronized (this.eventListenerSet) {
/* 318 */       Iterator i = this.eventListenerSet.iterator();
/* 319 */       while (i.hasNext()) {
/* 320 */         BridgeContext.EventListenerMememto elm = (BridgeContext.EventListenerMememto)i.next();
/* 321 */         NodeEventTarget et = elm.getTarget();
/* 322 */         if (et == evtTarget) {
/* 323 */           EventListener el = elm.getListener();
/* 324 */           boolean uc = elm.getUseCapture();
/* 325 */           String t = elm.getEventType();
/* 326 */           boolean in = elm.getNamespaced();
/* 327 */           if (et == null || el == null || t == null) {
/*     */             continue;
/*     */           }
/* 330 */           if (elm instanceof ImplementationEventListenerMememto) {
/* 331 */             String ns = elm.getNamespaceURI();
/* 332 */             es.removeImplementationEventListenerNS(ns, t, el, uc); continue;
/* 333 */           }  if (in) {
/* 334 */             String ns = elm.getNamespaceURI();
/* 335 */             et.removeEventListenerNS(ns, t, el, uc); continue;
/*     */           } 
/* 337 */           et.removeEventListener(t, el, uc);
/*     */         } 
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void removeDOMListeners() {
/* 348 */     SVGOMDocument doc = (SVGOMDocument)this.document;
/*     */     
/* 350 */     doc.removeEventListenerNS("http://www.w3.org/2001/xml-events", "DOMAttrModified", this.domAttrModifiedEventListener, true);
/*     */ 
/*     */ 
/*     */     
/* 354 */     doc.removeEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeInserted", this.domNodeInsertedEventListener, true);
/*     */ 
/*     */ 
/*     */     
/* 358 */     doc.removeEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeRemoved", this.domNodeRemovedEventListener, true);
/*     */ 
/*     */ 
/*     */     
/* 362 */     doc.removeEventListenerNS("http://www.w3.org/2001/xml-events", "DOMCharacterDataModified", this.domCharacterDataModifiedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 367 */     doc.removeAnimatedAttributeListener(this.animatedAttributeListener);
/*     */     
/* 369 */     CSSEngine cssEngine = doc.getCSSEngine();
/* 370 */     if (cssEngine != null) {
/* 371 */       cssEngine.removeCSSEngineListener(this.cssPropertiesChangedListener);
/*     */       
/* 373 */       cssEngine.dispose();
/* 374 */       doc.setCSSEngine(null);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void storeImplementationEventListenerNS(EventTarget t, String ns, String s, EventListener l, boolean b) {
/* 387 */     synchronized (this.eventListenerSet) {
/* 388 */       ImplementationEventListenerMememto m = new ImplementationEventListenerMememto(t, ns, s, l, b, this);
/*     */       
/* 390 */       this.eventListenerSet.add(m);
/*     */     } 
/*     */   }
/*     */   
/*     */   public BridgeContext createSubBridgeContext(SVGOMDocument newDoc) {
/* 395 */     CSSEngine eng = newDoc.getCSSEngine();
/* 396 */     if (eng != null) {
/* 397 */       return (BridgeContext)newDoc.getCSSEngine().getCSSContext();
/*     */     }
/*     */     
/* 400 */     BridgeContext subCtx = super.createSubBridgeContext(newDoc);
/* 401 */     if (isDynamic() && subCtx.isDynamic()) {
/* 402 */       setUpdateManager(subCtx, this.updateManager);
/* 403 */       if (this.updateManager != null) {
/*     */         ScriptingEnvironment scriptingEnvironment;
/* 405 */         if (newDoc.isSVG12()) {
/* 406 */           scriptingEnvironment = new SVG12ScriptingEnvironment(subCtx);
/*     */         } else {
/* 408 */           scriptingEnvironment = new ScriptingEnvironment(subCtx);
/*     */         } 
/* 410 */         scriptingEnvironment.loadScripts();
/* 411 */         scriptingEnvironment.dispatchSVGLoadEvent();
/* 412 */         if (newDoc.isSVG12()) {
/* 413 */           DefaultXBLManager xm = new DefaultXBLManager(newDoc, subCtx);
/*     */           
/* 415 */           setXBLManager(subCtx, xm);
/* 416 */           newDoc.setXBLManager(xm);
/* 417 */           xm.startProcessing();
/*     */         } 
/*     */       } 
/*     */     } 
/* 421 */     return subCtx;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void startMouseCapture(EventTarget target, boolean sendAll, boolean autoRelease) {
/* 429 */     this.mouseCaptureTarget = target;
/* 430 */     this.mouseCaptureSendAll = sendAll;
/* 431 */     this.mouseCaptureAutoRelease = autoRelease;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 438 */   public void stopMouseCapture() { this.mouseCaptureTarget = null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected static class ImplementationEventListenerMememto
/*     */     extends BridgeContext.EventListenerMememto
/*     */   {
/* 455 */     public ImplementationEventListenerMememto(EventTarget t, String s, EventListener l, boolean b, BridgeContext c) { super(t, s, l, b, c); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 467 */     public ImplementationEventListenerMememto(EventTarget t, String n, String s, EventListener l, boolean b, BridgeContext c) { super(t, n, s, l, b, c); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected class EventListenerWrapper
/*     */     implements EventListener
/*     */   {
/*     */     protected EventListener listener;
/*     */ 
/*     */ 
/*     */     
/*     */     private final SVG12BridgeContext this$0;
/*     */ 
/*     */ 
/*     */     
/*     */     public EventListenerWrapper(SVG12BridgeContext this$0, EventListener l) {
/* 485 */       this.this$0 = this$0;
/* 486 */       this.listener = l;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 493 */     public void handleEvent(Event evt) { this.listener.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 500 */     public String toString() { return super.toString() + " [wrapping " + this.listener.toString() + "]"; }
/*     */   }
/*     */   
/*     */   protected class XBLBindingListener
/*     */     implements BindingListener {
/*     */     private final SVG12BridgeContext this$0;
/*     */     
/* 507 */     protected XBLBindingListener(SVG12BridgeContext this$0) { this.this$0 = this$0; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void bindingChanged(Element bindableElement, Element shadowTree) {
/* 514 */       BridgeUpdateHandler h = BridgeContext.getBridgeUpdateHandler(bindableElement);
/* 515 */       if (h instanceof SVG12BridgeUpdateHandler) {
/* 516 */         SVG12BridgeUpdateHandler h12 = (SVG12BridgeUpdateHandler)h;
/*     */         try {
/* 518 */           h12.handleBindingEvent(bindableElement, shadowTree);
/*     */         } catch (Exception e) {
/* 520 */           this.this$0.userAgent.displayError(e);
/*     */         } 
/*     */       } 
/*     */     }
/*     */   }
/*     */   
/*     */   protected class XBLContentListener implements ContentSelectionChangedListener {
/*     */     private final SVG12BridgeContext this$0;
/*     */     
/* 529 */     protected XBLContentListener(SVG12BridgeContext this$0) { this.this$0 = this$0; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void contentSelectionChanged(ContentSelectionChangedEvent csce) {
/* 538 */       Element e = (Element)csce.getContentElement().getParentNode();
/* 539 */       if (e instanceof org.apache.batik.dom.svg12.XBLOMShadowTreeElement) {
/* 540 */         e = ((NodeXBL)e).getXblBoundElement();
/*     */       }
/* 542 */       BridgeUpdateHandler h = BridgeContext.getBridgeUpdateHandler(e);
/* 543 */       if (h instanceof SVG12BridgeUpdateHandler) {
/* 544 */         SVG12BridgeUpdateHandler h12 = (SVG12BridgeUpdateHandler)h;
/*     */         try {
/* 546 */           h12.handleContentSelectionChangedEvent(csce);
/*     */         } catch (Exception ex) {
/* 548 */           this.this$0.userAgent.displayError(ex);
/*     */         } 
/*     */       } 
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\SVG12BridgeContext.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */