/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import org.apache.batik.bridge.FocusManager;
/*     */ import org.apache.batik.dom.AbstractNode;
/*     */ import org.apache.batik.dom.events.DOMUIEvent;
/*     */ import org.apache.batik.dom.events.EventSupport;
/*     */ import org.apache.batik.dom.svg12.XBLEventSupport;
/*     */ import org.w3c.dom.Document;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.events.DocumentEvent;
/*     */ import org.w3c.dom.events.Event;
/*     */ import org.w3c.dom.events.EventTarget;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVG12FocusManager
/*     */   extends FocusManager
/*     */ {
/*  51 */   public SVG12FocusManager(Document doc) { super(doc); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void addEventListeners(Document doc) {
/*  58 */     AbstractNode n = (AbstractNode)doc;
/*  59 */     XBLEventSupport es = (XBLEventSupport)n.initializeEventSupport();
/*     */     
/*  61 */     this.mouseclickListener = new MouseClickTracker(this);
/*  62 */     es.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "click", this.mouseclickListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  67 */     this.mouseoverListener = new MouseOverTracker(this);
/*  68 */     es.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseover", this.mouseoverListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  73 */     this.mouseoutListener = new MouseOutTracker(this);
/*  74 */     es.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseout", this.mouseoutListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  79 */     this.domFocusInListener = new DOMFocusInTracker(this);
/*  80 */     es.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMFocusIn", this.domFocusInListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  85 */     this.domFocusOutListener = new FocusManager.DOMFocusOutTracker(this);
/*  86 */     es.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMFocusOut", this.domFocusOutListener, true);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void removeEventListeners(Document doc) {
/*  96 */     AbstractNode n = (AbstractNode)doc;
/*  97 */     XBLEventSupport es = (XBLEventSupport)n.getEventSupport();
/*     */     
/*  99 */     es.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "click", this.mouseclickListener, true);
/*     */ 
/*     */ 
/*     */     
/* 103 */     es.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseover", this.mouseoverListener, true);
/*     */ 
/*     */ 
/*     */     
/* 107 */     es.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "mouseout", this.mouseoutListener, true);
/*     */ 
/*     */ 
/*     */     
/* 111 */     es.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMFocusIn", this.domFocusInListener, true);
/*     */ 
/*     */ 
/*     */     
/* 115 */     es.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMFocusOut", this.domFocusOutListener, true);
/*     */   }
/*     */ 
/*     */   
/*     */   protected class MouseClickTracker
/*     */     extends FocusManager.MouseClickTracker
/*     */   {
/*     */     private final SVG12FocusManager this$0;
/*     */     
/* 124 */     protected MouseClickTracker(SVG12FocusManager this$0) { super(this$0); this.this$0 = this$0; }
/*     */     
/* 126 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */   
/*     */   protected class DOMFocusInTracker
/*     */     extends FocusManager.DOMFocusInTracker {
/*     */     private final SVG12FocusManager this$0;
/*     */     
/* 133 */     protected DOMFocusInTracker(SVG12FocusManager this$0) { super(this$0); this.this$0 = this$0; }
/*     */     
/* 135 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */   
/*     */   protected class MouseOverTracker
/*     */     extends FocusManager.MouseOverTracker {
/*     */     private final SVG12FocusManager this$0;
/*     */     
/* 142 */     protected MouseOverTracker(SVG12FocusManager this$0) { super(this$0); this.this$0 = this$0; }
/*     */     
/* 144 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */   
/*     */   protected class MouseOutTracker
/*     */     extends FocusManager.MouseOutTracker {
/*     */     private final SVG12FocusManager this$0;
/*     */     
/* 151 */     protected MouseOutTracker(SVG12FocusManager this$0) { super(this$0); this.this$0 = this$0; }
/*     */     
/* 153 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void fireDOMFocusInEvent(EventTarget target, EventTarget relatedTarget) {
/* 165 */     DocumentEvent docEvt = (DocumentEvent)((Element)target).getOwnerDocument();
/*     */     
/* 167 */     DOMUIEvent uiEvt = (DOMUIEvent)docEvt.createEvent("UIEvents");
/* 168 */     uiEvt.initUIEventNS("http://www.w3.org/2001/xml-events", "DOMFocusIn", true, false, null, 0);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 174 */     int limit = DefaultXBLManager.computeBubbleLimit((Node)relatedTarget, (Node)target);
/*     */     
/* 176 */     uiEvt.setBubbleLimit(limit);
/* 177 */     target.dispatchEvent(uiEvt);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void fireDOMFocusOutEvent(EventTarget target, EventTarget relatedTarget) {
/* 188 */     DocumentEvent docEvt = (DocumentEvent)((Element)target).getOwnerDocument();
/*     */     
/* 190 */     DOMUIEvent uiEvt = (DOMUIEvent)docEvt.createEvent("UIEvents");
/* 191 */     uiEvt.initUIEventNS("http://www.w3.org/2001/xml-events", "DOMFocusOut", true, false, null, 0);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 197 */     int limit = DefaultXBLManager.computeBubbleLimit((Node)target, (Node)relatedTarget);
/*     */     
/* 199 */     uiEvt.setBubbleLimit(limit);
/* 200 */     target.dispatchEvent(uiEvt);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\SVG12FocusManager.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */