/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import org.apache.batik.bridge.Bridge;
/*     */ import org.apache.batik.bridge.BridgeContext;
/*     */ import org.apache.batik.bridge.SVGTextElementBridge;
/*     */ import org.apache.batik.dom.AbstractNode;
/*     */ import org.apache.batik.dom.events.EventSupport;
/*     */ import org.apache.batik.dom.events.NodeEventTarget;
/*     */ import org.apache.batik.dom.svg12.XBLEventSupport;
/*     */ import org.apache.batik.dom.xbl.NodeXBL;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.events.Event;
/*     */ import org.w3c.dom.events.MutationEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVG12TextElementBridge
/*     */   extends SVGTextElementBridge
/*     */   implements SVG12BridgeUpdateHandler
/*     */ {
/*  51 */   public Bridge getInstance() { return new SVG12TextElementBridge(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void addTextEventListeners(BridgeContext ctx, NodeEventTarget e) {
/*  58 */     if (this.childNodeRemovedEventListener == null) {
/*  59 */       this.childNodeRemovedEventListener = new DOMChildNodeRemovedEventListener(this);
/*     */     }
/*     */     
/*  62 */     if (this.subtreeModifiedEventListener == null) {
/*  63 */       this.subtreeModifiedEventListener = new DOMSubtreeModifiedEventListener(this);
/*     */     }
/*     */ 
/*     */     
/*  67 */     SVG12BridgeContext ctx12 = (SVG12BridgeContext)ctx;
/*  68 */     AbstractNode n = (AbstractNode)e;
/*  69 */     XBLEventSupport evtSupport = (XBLEventSupport)n.initializeEventSupport();
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  74 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeRemoved", this.childNodeRemovedEventListener, true);
/*     */ 
/*     */     
/*  77 */     ctx12.storeImplementationEventListenerNS(e, "http://www.w3.org/2001/xml-events", "DOMNodeRemoved", this.childNodeRemovedEventListener, true);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*  83 */     evtSupport.addImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMSubtreeModified", this.subtreeModifiedEventListener, false);
/*     */ 
/*     */     
/*  86 */     ctx12.storeImplementationEventListenerNS(e, "http://www.w3.org/2001/xml-events", "DOMSubtreeModified", this.subtreeModifiedEventListener, false);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void removeTextEventListeners(BridgeContext ctx, NodeEventTarget e) {
/*  96 */     AbstractNode n = (AbstractNode)e;
/*  97 */     XBLEventSupport evtSupport = (XBLEventSupport)n.initializeEventSupport();
/*     */ 
/*     */     
/* 100 */     evtSupport.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMNodeRemoved", this.childNodeRemovedEventListener, true);
/*     */ 
/*     */     
/* 103 */     evtSupport.removeImplementationEventListenerNS("http://www.w3.org/2001/xml-events", "DOMSubtreeModified", this.subtreeModifiedEventListener, false);
/*     */   }
/*     */   
/*     */   protected class DOMChildNodeRemovedEventListener
/*     */     extends SVGTextElementBridge.DOMChildNodeRemovedEventListener
/*     */   {
/*     */     private final SVG12TextElementBridge this$0;
/*     */     
/* 111 */     protected DOMChildNodeRemovedEventListener(SVG12TextElementBridge this$0) { super(this$0); this.this$0 = this$0; }
/*     */ 
/*     */     
/* 114 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */   
/*     */   protected class DOMSubtreeModifiedEventListener
/*     */     extends SVGTextElementBridge.DOMSubtreeModifiedEventListener {
/*     */     private final SVG12TextElementBridge this$0;
/*     */     
/* 121 */     protected DOMSubtreeModifiedEventListener(SVG12TextElementBridge this$0) { super(this$0); this.this$0 = this$0; }
/*     */ 
/*     */     
/* 124 */     public void handleEvent(Event evt) { super.handleEvent(EventSupport.getUltimateOriginalEvent(evt)); }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 135 */   protected Node getFirstChild(Node n) { return ((NodeXBL)n).getXblFirstChild(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 143 */   protected Node getNextSibling(Node n) { return ((NodeXBL)n).getXblNextSibling(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 151 */   protected Node getParentNode(Node n) { return ((NodeXBL)n).getXblParentNode(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMCharacterDataModified(MutationEvent evt) {
/* 161 */     Node childNode = (Node)evt.getTarget();
/*     */     
/* 163 */     if (isParentDisplayed(childNode)) {
/* 164 */       if (getParentNode(childNode) != childNode.getParentNode()) {
/*     */ 
/*     */ 
/*     */         
/* 168 */         computeLaidoutText(this.ctx, this.e, this.node);
/*     */       } else {
/* 170 */         this.laidoutText = null;
/*     */       } 
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleBindingEvent(Element bindableElement, Element shadowTree) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 188 */   public void handleContentSelectionChangedEvent(ContentSelectionChangedEvent csce) { computeLaidoutText(this.ctx, this.e, this.node); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\SVG12TextElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */