/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import org.apache.batik.bridge.AbstractGraphicsNodeBridge;
/*     */ import org.apache.batik.bridge.Bridge;
/*     */ import org.apache.batik.bridge.BridgeContext;
/*     */ import org.apache.batik.bridge.GVTBuilder;
/*     */ import org.apache.batik.bridge.SVGUtilities;
/*     */ import org.apache.batik.gvt.CompositeGraphicsNode;
/*     */ import org.apache.batik.gvt.GraphicsNode;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.events.MutationEvent;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class XBLShadowTreeElementBridge
/*     */   extends AbstractGraphicsNodeBridge
/*     */ {
/*  51 */   public String getLocalName() { return "shadowTree"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  58 */   public String getNamespaceURI() { return "http://www.w3.org/2004/xbl"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  65 */   public Bridge getInstance() { return new XBLShadowTreeElementBridge(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GraphicsNode createGraphicsNode(BridgeContext ctx, Element e) {
/*  77 */     if (!SVGUtilities.matchUserAgent(e, ctx.getUserAgent())) {
/*  78 */       return null;
/*     */     }
/*     */     
/*  81 */     CompositeGraphicsNode cgn = new CompositeGraphicsNode();
/*     */     
/*  83 */     associateSVGContext(ctx, e, cgn);
/*     */     
/*  85 */     return cgn;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  93 */   protected GraphicsNode instantiateGraphicsNode() { return null; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 107 */   public void buildGraphicsNode(BridgeContext ctx, Element e, GraphicsNode node) { initializeDynamicSupport(ctx, e, node); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 115 */   public boolean getDisplay(Element e) { return true; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 122 */   public boolean isComposite() { return true; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleDOMNodeInsertedEvent(MutationEvent evt) {
/* 131 */     if (evt.getTarget() instanceof Element) {
/* 132 */       handleElementAdded((CompositeGraphicsNode)this.node, this.e, (Element)evt.getTarget());
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void handleElementAdded(CompositeGraphicsNode gn, Node parent, Element childElt) {
/* 145 */     GVTBuilder builder = this.ctx.getGVTBuilder();
/* 146 */     GraphicsNode childNode = builder.build(this.ctx, childElt);
/* 147 */     if (childNode == null) {
/*     */       return;
/*     */     }
/*     */ 
/*     */     
/* 152 */     int idx = -1;
/* 153 */     for (Node ps = childElt.getPreviousSibling(); ps != null; 
/* 154 */       ps = ps.getPreviousSibling()) {
/* 155 */       if (ps.getNodeType() != 1)
/*     */         continue; 
/* 157 */       Element pse = (Element)ps;
/* 158 */       CompositeGraphicsNode compositeGraphicsNode = this.ctx.getGraphicsNode(pse);
/* 159 */       while (compositeGraphicsNode != null && compositeGraphicsNode.getParent() != gn)
/*     */       {
/*     */         
/* 162 */         compositeGraphicsNode = compositeGraphicsNode.getParent();
/*     */       }
/* 164 */       if (compositeGraphicsNode == null)
/*     */         continue; 
/* 166 */       idx = gn.indexOf(compositeGraphicsNode);
/* 167 */       if (idx == -1) {
/*     */         continue;
/*     */       }
/*     */       
/*     */       break;
/*     */     } 
/* 173 */     idx++;
/* 174 */     gn.add(idx, childNode);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\XBLShadowTreeElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */