/*    */ package org.apache.batik.bridge;
/*    */ 
/*    */ import java.awt.geom.AffineTransform;
/*    */ import java.awt.geom.Rectangle2D;
/*    */ import java.util.HashMap;
/*    */ import java.util.Iterator;
/*    */ import java.util.LinkedList;
/*    */ import org.apache.batik.dom.anim.AnimationTarget;
/*    */ import org.apache.batik.dom.anim.AnimationTargetListener;
/*    */ import org.apache.batik.dom.svg.SVGAnimationTargetContext;
/*    */ import org.w3c.dom.Element;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class AnimatableSVGBridge
/*    */   extends AbstractSVGBridge
/*    */   implements SVGAnimationTargetContext
/*    */ {
/*    */   protected Element e;
/*    */   protected BridgeContext ctx;
/*    */   protected HashMap targetListeners;
/*    */   
/*    */   public void addTargetListener(String pn, AnimationTargetListener l) {
/* 63 */     if (this.targetListeners == null) {
/* 64 */       this.targetListeners = new HashMap();
/*    */     }
/* 66 */     LinkedList ll = (LinkedList)this.targetListeners.get(pn);
/* 67 */     if (ll == null) {
/* 68 */       ll = new LinkedList();
/* 69 */       this.targetListeners.put(pn, ll);
/*    */     } 
/* 71 */     ll.add(l);
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public void removeTargetListener(String pn, AnimationTargetListener l) {
/* 78 */     LinkedList ll = (LinkedList)this.targetListeners.get(pn);
/* 79 */     ll.remove(l);
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   protected void fireBaseAttributeListeners(String pn) {
/* 87 */     if (this.targetListeners != null) {
/* 88 */       LinkedList ll = (LinkedList)this.targetListeners.get(pn);
/* 89 */       if (ll != null) {
/* 90 */         Iterator it = ll.iterator();
/* 91 */         while (it.hasNext()) {
/* 92 */           AnimationTargetListener l = (AnimationTargetListener)it.next();
/*    */           
/* 94 */           l.baseValueChanged((AnimationTarget)this.e, null, pn, true);
/*    */         } 
/*    */       } 
/*    */     } 
/*    */   }
/*    */   
/*    */   public abstract float getFontSize();
/*    */   
/*    */   public abstract float getViewportHeight();
/*    */   
/*    */   public abstract float getViewportWidth();
/*    */   
/*    */   public abstract AffineTransform getGlobalTransform();
/*    */   
/*    */   public abstract AffineTransform getCTM();
/*    */   
/*    */   public abstract void setScreenTransform(AffineTransform paramAffineTransform);
/*    */   
/*    */   public abstract AffineTransform getScreenTransform();
/*    */   
/*    */   public abstract Rectangle2D getBBox();
/*    */   
/*    */   public abstract float getPixelToMM();
/*    */   
/*    */   public abstract float getPixelUnitToMillimeter();
/*    */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\AnimatableSVGBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */