/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.Rectangle;
/*     */ import java.awt.Shape;
/*     */ import java.awt.geom.AffineTransform;
/*     */ import java.awt.geom.Rectangle2D;
/*     */ import java.awt.image.BufferedImage;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import org.apache.batik.ext.awt.geom.RectListManager;
/*     */ import org.apache.batik.gvt.renderer.ImageRenderer;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RepaintManager
/*     */ {
/*     */   static final int COPY_OVERHEAD = 10000;
/*     */   static final int COPY_LINE_OVERHEAD = 10;
/*     */   protected ImageRenderer renderer;
/*     */   
/*  54 */   public RepaintManager(ImageRenderer r) { this.renderer = r; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Collection updateRendering(Collection areas) throws InterruptedException {
/*  64 */     this.renderer.flush(areas);
/*  65 */     List rects = new ArrayList(areas.size());
/*  66 */     AffineTransform at = this.renderer.getTransform();
/*     */     
/*  68 */     Iterator i = areas.iterator();
/*  69 */     while (i.hasNext()) {
/*  70 */       Shape s = (Shape)i.next();
/*  71 */       s = at.createTransformedShape(s);
/*  72 */       Rectangle2D r2d = s.getBounds2D();
/*  73 */       int x0 = (int)Math.floor(r2d.getX());
/*  74 */       int y0 = (int)Math.floor(r2d.getY());
/*  75 */       int x1 = (int)Math.ceil(r2d.getX() + r2d.getWidth());
/*  76 */       int y1 = (int)Math.ceil(r2d.getY() + r2d.getHeight());
/*     */ 
/*     */       
/*  79 */       Rectangle r = new Rectangle(x0 - 1, y0 - 1, x1 - x0 + 3, y1 - y0 + 3);
/*     */       
/*  81 */       rects.add(r);
/*     */     } 
/*  83 */     RectListManager devRLM = null;
/*     */     try {
/*  85 */       devRLM = new RectListManager(rects);
/*  86 */       devRLM.mergeRects(10000, 10);
/*     */     } catch (Exception e) {
/*  88 */       e.printStackTrace();
/*     */     } 
/*     */     
/*  91 */     this.renderer.repaint(devRLM);
/*  92 */     return devRLM;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setupRenderer(AffineTransform u2d, boolean dbr, Shape aoi, int width, int height) {
/* 110 */     this.renderer.setTransform(u2d);
/* 111 */     this.renderer.setDoubleBuffered(dbr);
/* 112 */     this.renderer.updateOffScreen(width, height);
/* 113 */     this.renderer.clearOffScreen();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/* 121 */   public BufferedImage getOffScreen() { return this.renderer.getOffScreen(); }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\RepaintManager.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */