/*     */ package org.apache.batik.bridge;
/*     */ 
/*     */ import java.awt.Shape;
/*     */ import org.apache.batik.gvt.CompositeShapePainter;
/*     */ import org.apache.batik.gvt.ShapeNode;
/*     */ import org.apache.batik.gvt.ShapePainter;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class SVGDecoratedShapeElementBridge
/*     */   extends SVGShapeElementBridge
/*     */ {
/*  58 */   ShapePainter createFillStrokePainter(BridgeContext ctx, Element e, ShapeNode shapeNode) { return super.createShapePainter(ctx, e, shapeNode); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  67 */   ShapePainter createMarkerPainter(BridgeContext ctx, Element e, ShapeNode shapeNode) { return PaintServer.convertMarkers(e, shapeNode, ctx); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected ShapePainter createShapePainter(BridgeContext ctx, Element e, ShapeNode shapeNode) {
/*  84 */     ShapePainter shapePainter, fillAndStroke = createFillStrokePainter(ctx, e, shapeNode);
/*     */     
/*  86 */     ShapePainter markerPainter = createMarkerPainter(ctx, e, shapeNode);
/*     */     
/*  88 */     Shape shape = shapeNode.getShape();
/*     */ 
/*     */     
/*  91 */     if (markerPainter != null) {
/*  92 */       if (fillAndStroke != null) {
/*  93 */         CompositeShapePainter cp = new CompositeShapePainter(shape);
/*  94 */         cp.addShapePainter(fillAndStroke);
/*  95 */         cp.addShapePainter(markerPainter);
/*  96 */         shapePainter = cp;
/*     */       } else {
/*  98 */         shapePainter = markerPainter;
/*     */       } 
/*     */     } else {
/* 101 */       shapePainter = fillAndStroke;
/*     */     } 
/* 103 */     return shapePainter;
/*     */   }
/*     */   
/*     */   protected void handleCSSPropertyChanged(int property) {
/* 107 */     switch (property) {
/*     */       case 34:
/*     */       case 35:
/*     */       case 36:
/* 111 */         if (!this.hasNewShapePainter) {
/* 112 */           this.hasNewShapePainter = true;
/* 113 */           ShapeNode shapeNode = (ShapeNode)this.node;
/* 114 */           shapeNode.setShapePainter(createShapePainter(this.ctx, this.e, shapeNode));
/*     */         } 
/*     */         return;
/*     */     } 
/* 118 */     super.handleCSSPropertyChanged(property);
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\SVGDecoratedShapeElementBridge.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */