/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import org.apache.batik.dom.svg12.XBLOMContentElement;
/*     */ import org.w3c.dom.Element;
/*     */ import org.w3c.dom.Node;
/*     */ import org.w3c.dom.NodeList;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DefaultContentSelector
/*     */   extends AbstractContentSelector
/*     */ {
/*     */   protected SelectedNodes selectedContent;
/*     */   
/*  49 */   public DefaultContentSelector(ContentManager cm, XBLOMContentElement content, Element bound) { super(cm, content, bound); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public NodeList getSelectedContent() {
/*  57 */     if (this.selectedContent == null) {
/*  58 */       this.selectedContent = new SelectedNodes(this);
/*     */     }
/*  60 */     return this.selectedContent;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   boolean update() {
/*  71 */     if (this.selectedContent == null) {
/*  72 */       this.selectedContent = new SelectedNodes(this);
/*  73 */       return true;
/*     */     } 
/*  75 */     return this.selectedContent.update();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected class SelectedNodes
/*     */     implements NodeList
/*     */   {
/*     */     protected ArrayList nodes;
/*     */ 
/*     */     
/*     */     private final DefaultContentSelector this$0;
/*     */ 
/*     */ 
/*     */     
/*     */     public SelectedNodes(DefaultContentSelector this$0) {
/*  92 */       this.this$0 = this$0; this.nodes = new ArrayList(10);
/*  93 */       update();
/*     */     }
/*     */     
/*     */     protected boolean update() {
/*  97 */       ArrayList oldNodes = (ArrayList)this.nodes.clone();
/*  98 */       this.nodes.clear();
/*  99 */       for (Node n = this.this$0.boundElement.getFirstChild(); n != null; n = n.getNextSibling()) {
/* 100 */         if (!this.this$0.isSelected(n))
/*     */         {
/*     */           
/* 103 */           this.nodes.add(n); } 
/*     */       } 
/* 105 */       int nodesSize = this.nodes.size();
/* 106 */       if (oldNodes.size() != nodesSize) {
/* 107 */         return true;
/*     */       }
/* 109 */       for (int i = 0; i < nodesSize; i++) {
/* 110 */         if (oldNodes.get(i) != this.nodes.get(i)) {
/* 111 */           return true;
/*     */         }
/*     */       } 
/* 114 */       return false;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public Node item(int index) {
/* 121 */       if (index < 0 || index >= this.nodes.size()) {
/* 122 */         return null;
/*     */       }
/* 124 */       return (Node)this.nodes.get(index);
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 131 */     public int getLength() { return this.nodes.size(); }
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\DefaultContentSelector.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */