/*     */ package org.apache.batik.bridge.svg12;
/*     */ 
/*     */ import java.util.Collections;
/*     */ import java.util.Iterator;
/*     */ import org.apache.batik.bridge.BridgeContext;
/*     */ import org.apache.batik.bridge.SVGBridgeExtension;
/*     */ import org.w3c.dom.Element;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SVG12BridgeExtension
/*     */   extends SVGBridgeExtension
/*     */ {
/*  46 */   public float getPriority() { return 0.0F; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  55 */   public Iterator getImplementedExtensions() { return Collections.EMPTY_LIST.iterator(); }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  63 */   public String getAuthor() { return "The Apache Batik Team."; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  70 */   public String getContactAddress() { return "batik-dev@xmlgraphics.apache.org"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  78 */   public String getURL() { return "http://xml.apache.org/batik"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*  87 */   public String getDescription() { return "The required SVG 1.2 tags"; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void registerTags(BridgeContext ctx) {
/* 100 */     super.registerTags(ctx);
/*     */ 
/*     */     
/* 103 */     ctx.putBridge(new SVGFlowRootElementBridge());
/* 104 */     ctx.putBridge(new SVGMultiImageElementBridge());
/* 105 */     ctx.putBridge(new SVGSolidColorElementBridge());
/*     */     
/* 107 */     ctx.putBridge(new SVG12TextElementBridge());
/*     */ 
/*     */     
/* 110 */     ctx.putBridge(new XBLShadowTreeElementBridge());
/* 111 */     ctx.putBridge(new XBLContentElementBridge());
/*     */ 
/*     */     
/* 114 */     ctx.setDefaultBridge(new BindableElementBridge());
/*     */ 
/*     */     
/* 117 */     ctx.putReservedNamespaceURI(null);
/* 118 */     ctx.putReservedNamespaceURI("http://www.w3.org/2000/svg");
/* 119 */     ctx.putReservedNamespaceURI("http://www.w3.org/2004/xbl");
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean isDynamicElement(Element e) {
/* 130 */     String ns = e.getNamespaceURI();
/* 131 */     if ("http://www.w3.org/2004/xbl".equals(ns)) {
/* 132 */       return true;
/*     */     }
/* 134 */     if (!"http://www.w3.org/2000/svg".equals(ns)) {
/* 135 */       return false;
/*     */     }
/* 137 */     String ln = e.getLocalName();
/* 138 */     if (ln.equals("script") || ln.equals("handler") || ln.startsWith("animate") || ln.equals("set"))
/*     */     {
/*     */ 
/*     */       
/* 142 */       return true;
/*     */     }
/* 144 */     return false;
/*     */   }
/*     */ }


/* Location:              C:\Program Files (x86)\IBM\WebSphere\AppServer\profiles\ctgAppSrv01\installedApps\ctgCell01\MAXIMO.ear\maximouiweb.war\WEB-INF\classes\!\com\ibm\tivoli\maximo\report\control\svgtools\batik-bridge.jar!\org\apache\batik\bridge\svg12\SVG12BridgeExtension.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       1.0.7
 */